﻿'Imports ThinkGeo.MapSuite.DesktopEdition
'Imports ThinkGeo.MapSuite.Core
'Imports MapUtilities
Imports System.Collections.ObjectModel
Imports Infragistics.Win.UltraWinGrid
Imports Infragistics.Win.UltraWinEditors
Imports Infragistics.Win
Imports Infragistics.Win.UltraWinToolbars

Public Class frmDynamicSegmentationWiz
   'Private moFeatureDisplayLayer As InMemoryFeatureLayer
   'Private moMainMap As CustomWinformsMap
   'Private moStartEndPointMemLayer As InMemoryFeatureLayer
   'Private moSelectedPolyLayer As InMemoryFeatureLayer
   Private moShapePartDatasets As Collection(Of DataSet)
   'Private moPrescribeFeatures As Collection(Of Feature)
   'Private moPrescribeFeature As Feature
   'Private moPrescribeShape As BaseShape
   'Private meDistUnits As DistanceUnit = DistanceUnit.Feet
   'Private moDynamicSegmentationOverlay As LayerOverlay
   'Private moFeatureOverlay As LayerOverlay
   'Private moSelectedPolyOverlay As LayerOverlay
   Private miShapePartId As Integer = -1
   Private miFeatureKey As Integer = 0
   Private miCurTabNum As Integer = 0
   Private miOrgKey As Integer
   'Private moSQLLayer As CustomSQLFeatureLayer
   Private msNameColumn As String
   Private msFeatureKeyColumn As String
   Private mbSetSegmentLength As Boolean = True
   Private mbUpdateFromCellChangeIsRunning As Boolean = False
   'Added 2 member variables to keep up with the Featrure and Part where a Segment Row is Deleted
   Private miFeatureKeyForDelete As Integer = 0
   Private miPartIdForDelete As Integer = -1
   Private miSegmentIdForDelete As Integer = 0
   Private Const csSegmentLable As String = "SegmentLabel"
   Private Const csEditing As String = "Editing"
   Private Const csEditingYes As String = "Yes"
   Private Const csEditingNo As String = "No"

   'To help control Zoom In and Out, Jamie Iriwn 6/30/2016
   '   Private WithEvents moTrackInteractiveOverlay As TrackInteractiveOverlay

   Private Enum EnumSourceShapeMode
      LineMode = 1
      PolygonMode = 2
   End Enum
   Dim meSourceMode As EnumSourceShapeMode
   Dim moLineSegmentCollection As LineSegmentCollection
   ''Added meStartPoint to allow us to know if we need to set the Referse CheckBox in the Load event, Jamie Irwin 8/19/2016
   'Dim meStartPoint As StartingPoint = Nothing ' StartingPoint.FirstPoint

   Public Sub New()
      InitializeComponent()

      'NOTE Changed from passing in the oDslFeature parameter to a collection of features
      'so we can prescribe from the map or tree view, Jamie Irwin 6/27/2016

      'Added an optional parameter oLineSegments to allow the user to edit the segmentation of an existing activity
      'Jamie Irwin 8/19/2016
      'moLineSegmentCollection = oLineSegments

      ''***** oPrescribeShape will always be either a line or a polygon.
      ''moDslFeature = oDslFeature
      'moPrescribeFeatures = oPrescribeFeatures
      'moPrescribeFeature = moPrescribeFeatures(0) ' moDslFeature.MapShape.GetFeature ' oPrescribeFeature
      'moPrescribeShape = moPrescribeFeature.GetShape  ' oPrescribeFeature.GetShape
      'miOrgKey = CInt(moPrescribeFeature.ColumnValues("OrgKeyId"))      ' moDslFeature.OrgKeyId    ' 
      'moSQLLayer = oSQLLayer ' moDslFeature.SQLLayer
      'Select Case moSQLLayer.LayerID
      '   Case 1002   'Stands
      '      msNameColumn = "StandName"
      '      msFeatureKeyColumn = "StandKey"
      '   Case 1005   'Tracts
      '      msNameColumn = "TractName"
      '      msFeatureKeyColumn = "TractKey"
      '   Case Else   'Assume DslName
      '      msNameColumn = "DslName"
      '      msFeatureKeyColumn = "DslKey"
      'End Select
      'moMainMap = oMap ' moDslFeature.Map
      'moDisplayMap.MapUnit = moMainMap.MapUnit
      'moTrackInteractiveOverlay = moDisplayMap.TrackOverlay

      meSourceMode = EnumSourceShapeMode.LineMode
      'Select Case moPrescribeShape.GetWellKnownType
      '   Case WellKnownType.Polygon
      '      meSourceMode = EnumSourceShapeMode.PolygonMode
      '      Dim oLine As New LineShape
      '      For Each oVertex In CType(moPrescribeShape, PolygonShape).OuterRing.Vertices
      '         oLine.Vertices.Add(oVertex)
      '      Next oVertex
      '      moPrescribeShape = oLine
      '   Case WellKnownType.Multipolygon
      '      meSourceMode = EnumSourceShapeMode.PolygonMode
      '      Dim oMultiline As New MultilineShape
      '      Dim oLine As LineShape
      '      For Each oPolygon As PolygonShape In CType(moPrescribeShape, MultipolygonShape).Polygons
      '         oLine = New LineShape
      '         For Each oVertex In oPolygon.OuterRing.Vertices
      '            oLine.Vertices.Add(oVertex)
      '         Next oVertex
      '         oMultiline.Lines.Add(oLine)
      '      Next oPolygon
      '      moPrescribeShape = oMultiline
      'End Select
      'ZoomLevelHelper.ApplyCustomZoomLevels(moDisplayMap.ZoomLevelSet, ZoomLevelHelper.EnumSymbolType.None)
   End Sub

   Private Sub frmDynamicSegmentationWiz_FormClosed(sender As Object, e As Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
      'Save the form size and location, Jamie Irwin 6/28/2016
      'Utils.SaveFormSettings(Me, True)
   End Sub

   Private Sub Form1_Load(sender As Object, e As System.EventArgs) Handles Me.Load
      'Dim oDynSegLayer As InMemoryFeatureLayer
      'Dim oFeatureCols As New Collection(Of FeatureSourceColumn)
      'Dim oStartPoint As PointShape = Nothing
      'Dim oEndPoint As PointShape = Nothing

      ''Reset the form to the size it was last time used, Jamie Iriwn 6/28/2016
      'Utils.GetFormSettings(Me, True)

      ''***** Create an InMemoryFeatureLayer to display the feature
      ''***** to which the prescription is being applied 
      'moFeatureDisplayLayer = New InMemoryFeatureLayer
      'moFeatureDisplayLayer.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = LineStyles.CreateSimpleLineStyle(GeoColor.SimpleColors.Black, 1, True)
      ''Added line below to se the DefaultAreaStyle so that Polygons will display, Jamie Irwin 8/23/2016
      'moFeatureDisplayLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle =
      '      AreaStyles.CreateSimpleAreaStyle(GeoColor.SimpleColors.Transparent, GeoColor.SimpleColors.Black, 1)
      'moFeatureDisplayLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20
      ''Moved below to mInitializeShapePartDatasets
      ''      moFeatureDisplayLayer.InternalFeatures.Add(moPrescribeShape.GetFeature)

      ''***** Add this layer to its overlay
      'moFeatureOverlay = New LayerOverlay
      'moFeatureOverlay.Layers.Add(moFeatureDisplayLayer)

      ''***** Create InMemoryFeatureLayer(s) to display dynamic segements
      ''***** which represent lines along which the prescription will be applied
      'moDynamicSegmentationOverlay = New LayerOverlay
      Dim sBaseDynSegName As String
      If meSourceMode = EnumSourceShapeMode.LineMode Then
         sBaseDynSegName = "Line"
      Else
         sBaseDynSegName = "Polygon"
      End If

      '***** Create a separate InMemoryFeatureLayer for each 
      '***** part of the feature
      'Added code to Lable the Segments, Jamie Irwin 8/23/2016
      'Dim oLineStyle As LineStyle = LineStyles.CreateSimpleLineStyle(GeoColor.SimpleColors.Black, 1, False)
      'Dim oEditingSymbol As LineStyle = LineStyles.CreateSimpleLineStyle(GeoColor.SimpleColors.Red, 3, False)
      'Dim oNotEditingSymbol As LineStyle = LineStyles.CreateSimpleLineStyle(GeoColor.SimpleColors.LightBlue, 3, False)
      'Dim oPointStyle As PointStyle = PointStyles.CreateSimplePointStyle(PointSymbolType.Circle, GeoColor.SimpleColors.BrightBlue, 8)
      'oPointStyle.DrawingLevel = DrawingLevel.LevelFour

      'Dim oSegLableStyle As TextStyle = TextStyles.CreateSimpleTextStyle(csSegmentLable, "Verdana", 10, DrawingFontStyles.Regular, GeoColor.SimpleColors.Black)
      'oSegLableStyle.SplineType = SplineType.StandardSplining
      'oSegLableStyle.DrawingLevel = DrawingLevel.LabelLevel
      'oSegLableStyle.XOffsetInPixel = 8
      'oSegLableStyle.YOffsetInPixel = 8
      ''Added code to set up a Value Style so we can have a visual distinction for which segment is being edited,
      ''Jamie Iriwn 8/24/2016
      'Dim oSegValueStyle As New ValueStyle
      'Dim oItem As ValueItem
      'With oSegValueStyle
      '   .ColumnName = csEditing
      '   oItem = New ValueItem(csEditingNo, oNotEditingSymbol)
      '   .ValueItems.Add(oItem)
      '   oItem = New ValueItem(csEditingYes, oEditingSymbol)
      '   .ValueItems.Add(oItem)
      'End With

      'If moPrescribeShape.GetWellKnownType = WellKnownType.Line Then
      '   oDynSegLayer = New InMemoryFeatureLayer()
      '   oDynSegLayer.Name = sBaseDynSegName + "0"
      '   oDynSegLayer.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(oLineStyle)
      '   oDynSegLayer.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(oPointStyle)
      '   oDynSegLayer.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(oSegLableStyle)
      '   oDynSegLayer.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(oSegValueStyle)
      '   oDynSegLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20
      '   moDynamicSegmentationOverlay.Layers.Add(oDynSegLayer)
      'Else
      '   For i As Integer = 0 To CType(moPrescribeShape, MultilineShape).Lines.Count - 1
      '      oDynSegLayer = New InMemoryFeatureLayer()
      '      oDynSegLayer.Name = sBaseDynSegName + i.ToString
      '      oDynSegLayer.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(oLineStyle)
      '      oDynSegLayer.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(oPointStyle)
      '      oDynSegLayer.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(oSegLableStyle)
      '      oDynSegLayer.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(oSegValueStyle)
      '      oDynSegLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20
      '      moDynamicSegmentationOverlay.Layers.Add(oDynSegLayer)
      '   Next i
      'End If

      ''***** Create an InMemoryFeatureLayer to display the start and end points for the
      ''***** features that are being prescribed to. If the user is prescribing to a line 
      ''***** feature there will only be two points. The start point will be the first vertext feature 
      ''***** of the first line in the lines collection. The end point will be the last
      ''***** vertex of the last line feature. Polygons will be treated differenctly, with 
      ''***** separate Start/End points for each outer ring in the polygon.
      'Dim oFeatures As New Collection(Of Feature)
      'Dim oColVals As New Dictionary(Of String, String)
      'oColVals.Add("Label", String.Empty)

      'oFeatureCols.Add(New FeatureSourceColumn("Label"))

      'Dim oStartSymbol As PointStyle = PointStyles.CreateSimplePointStyle(PointSymbolType.Square, GeoColor.SimpleColors.BrightGreen, 10)
      'Dim oEndSymbol As PointStyle = PointStyles.CreateSimplePointStyle(PointSymbolType.Square, GeoColor.SimpleColors.Red, 10)
      'Dim oStartEndSymbol As PointStyle = PointStyles.CreateSimpleSquareStyle(GeoColor.SimpleColors.Red, 10)

      'Dim oValueStyle As New ValueStyle()
      'With oValueStyle
      '   .ColumnName = "Label"
      '   Dim oValueItem As New ValueItem("Start", oStartSymbol)
      '   .ValueItems.Add(oValueItem)
      '   oValueItem = New ValueItem("End", oEndSymbol)
      '   .ValueItems.Add(oValueItem)
      '   oValueItem = New ValueItem("Start/End", oStartEndSymbol)
      '   .ValueItems.Add(oValueItem)
      'End With

      'Dim oTextStyle As TextStyle = TextStyles.CreateSimpleTextStyle("Label", "Verdana", 10, DrawingFontStyles.Regular, GeoColor.SimpleColors.Black)
      'oTextStyle.XOffsetInPixel = 8
      'moStartEndPointMemLayer = New InMemoryFeatureLayer(oFeatureCols, oFeatures)
      'moStartEndPointMemLayer.ZoomLevelSet.ZoomLevel01.DefaultTextStyle.DrawingLevel = DrawingLevel.LabelLevel
      'moStartEndPointMemLayer.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(oValueStyle)
      'moStartEndPointMemLayer.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(oTextStyle)
      'moStartEndPointMemLayer.ZoomLevelSet.ZoomLevel01.DefaultTextStyle.BestPlacement = True
      'moStartEndPointMemLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20

      ''moPointLayer = New InMemoryFeatureLayer
      ''moPointLayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle = PointStyles.CreateSimplePointStyle(PointSymbolType.Circle, GeoColor.SimpleColors.BrightBlue, 8)
      ''moPointLayer.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = LineStyles.CreateSimpleLineStyle(GeoColor.SimpleColors.BrightRed, 3, False)
      ''moPointLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20

      ''moDynamicSegmentationOverlay.Layers.Add(moPointLayer)
      'moFeatureOverlay.Layers.Add(moStartEndPointMemLayer)

      'moSelectedPolyOverlay = New LayerOverlay
      'moSelectedPolyLayer = New InMemoryFeatureLayer
      'moSelectedPolyLayer.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = LineStyles.CreateSimpleLineStyle(GeoColor.SimpleColors.BrightBlue, 2, False)
      'moSelectedPolyLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20
      'moSelectedPolyOverlay.Layers.Add(moSelectedPolyLayer)
      'moDisplayMap.Overlays.Add(moSelectedPolyOverlay)

      'moDisplayMap.Overlays.Add(moFeatureOverlay)
      'moDisplayMap.Overlays.Add(moDynamicSegmentationOverlay)




      ''Moved the setting of the extent to inside mInitializeShapePartDatasets, Jamie Irwin 6/28/2016
      ''moDisplayMap.CurrentExtent = moPrescribeShape.GetBoundingBox
      'mSetupGrid()
      ''After the Grid is Setup, we may need to set the CheckBox for the Reverse,
      ''Jamie iriwn 8/19/2016
      'If meStartPoint = StartingPoint.LastPoint Then
      '   Me.chkReverse.Checked = True
      'End If
      'If IsNothing(moLineSegmentCollection) Then
      '   Me.ubtnSaveSegmentation.Visible = False
      'Else
      '   Me.ubtnSaveSegmentation.Visible = True
      'End If
      ''We also need to draw the inital segments, Jamie Irwin 7/1/2016
      'mCreateDynamicSegments()
      'moDisplayMap.Refresh()
      'CType(Me.utmMapTools.Tools(My.Resources.frmDynamicSegmentation.IDSetStartPoint), StateButtonTool).Checked = True
      'Me.btnPrescribe.Enabled = False

   End Sub
   Private Function mCreateShapePartDataset(iShapeIndex As Integer) As DataSet
      Dim oSegments As DataTable
      'Dim oShapePartTable As DataTable
      Dim oColumn As DataColumn
      Dim oShapePartDataset As New DataSet()
      Dim sBaseName As String

      If meSourceMode = EnumSourceShapeMode.LineMode Then
         sBaseName = "Line "
      Else
         sBaseName = "Polygon "
      End If

      oShapePartDataset.DataSetName = sBaseName + " " + (iShapeIndex + 1).ToString
      'To test, having all the data on one line, commented out some and moved other stuff, Jamie Irwin 6/20/2016
      'oShapePartTable = New DataTable(LineSegment.csShapePartsTableName)

      'oColumn = New DataColumn(LineSegment.csShapePartCol, GetType(String))
      'oShapePartTable.Columns.Add(oColumn)

      'oColumn = New DataColumn(LineSegment.csShapePartIdCol, GetType(Integer))
      'oShapePartTable.Columns.Add(oColumn)

      oSegments = New DataTable(LineSegment.csSegmentsTableName)
      oColumn = New DataColumn(LineSegment.csPrescribeToSegment, GetType(Boolean))
      oSegments.Columns.Add(oColumn)

      oColumn = New DataColumn(LineSegment.csFeatureNameCol, GetType(String))
      oSegments.Columns.Add(oColumn)
      'Added a column to hold the feature Key, Jamie Irwin 6/28/2016
      oColumn = New DataColumn(LineSegment.csFeatureKeyCol, GetType(Integer))
      oSegments.Columns.Add(oColumn)

      oColumn = New DataColumn(LineSegment.csShapePartCol, GetType(String))
      oSegments.Columns.Add(oColumn)

      oColumn = New DataColumn(LineSegment.csSegmentNumberCol, GetType(String))
      oSegments.Columns.Add(oColumn)

      oColumn = New DataColumn(LineSegment.csShapePartIdCol, GetType(Integer))
      oSegments.Columns.Add(oColumn)

      oColumn = New DataColumn(LineSegment.csStartDistCol, GetType(Integer))
      oSegments.Columns.Add(oColumn)

      oColumn = New DataColumn(LineSegment.csSegmentLengthCol, GetType(Integer))
      oSegments.Columns.Add(oColumn)

      ''oColumn = New DataColumn(LineSegment.csShapePartIdCol, GetType(Integer))
      ''oSegments.Columns.Add(oColumn)
      ''ShapePartDataset = New DataSet
      ''oShapePartDataset.Tables.Add(oShapePartTable)
      oShapePartDataset.Tables.Add(oSegments)

      'Dim oShapePartRelation As New DataRelation("ShapePartRelation", oShapePartTable.Columns(LineSegment.csShapePartIdCol), oSegments.Columns(LineSegment.csShapePartIdCol))
      'oShapePartDataset.Relations.Add(oShapePartRelation)

      Return oShapePartDataset
   End Function
   Private Sub mSetupGrid()
      mInitializeShapePartDatasets()
   End Sub
   Private Sub mInitializeShapePartDatasets()
      'Dim oShapePartsTable As DataTable
      Dim oSegments As New DataTable("Segments")
      'Dim oRow As DataRow
      Dim sBasePartName As String
      'Dim oExtent As RectangleShape = Nothing
      'Dim oExtentRectangles As New Collection(Of RectangleShape)

      If meSourceMode = EnumSourceShapeMode.LineMode Then
         sBasePartName = "Line "
      Else
         sBasePartName = "Polygon "
      End If

      moShapePartDatasets = New Collection(Of DataSet)
      moShapePartDatasets.Add(mCreateShapePartDataset(0))
      oSegments = moShapePartDatasets(0).Tables(LineSegment.csSegmentsTableName)
      Dim oRow As DataRow
      oRow = oSegments.NewRow
      oRow(LineSegment.csPrescribeToSegment) = False
      oRow(LineSegment.csFeatureNameCol) = "Feature 1"
      'Added the FeatureKeyColumn, Jamie Iriwn 6/28/2016
      oRow(LineSegment.csFeatureKeyCol) = 999
      oRow(LineSegment.csShapePartCol) = 1
      oRow(LineSegment.csSegmentNumberCol) = "1"
      oRow(LineSegment.csStartDistCol) = 0
      oRow(LineSegment.csSegmentLengthCol) = 100
      oRow(LineSegment.csShapePartIdCol) = 0
      oSegments.Rows.Add(oRow)

      'Added the For Loop so we can prescribie to multiple features selected on the Map or in a Folder.
      'Jamie Iriwn 6/27/2016
      'For Each oFeature As Feature In moPrescribeFeatures
      '   'Capture the extent of all the features...
      '   'If IsNothing(oExtent) Then
      '   '   oExtent = oFeature.GetShape.GetBoundingBox
      '   'Else
      '   '   oExtent = oExtent.Union(oFeature.GetShape.GetBoundingBox).GetBoundingBox
      '   'End If
      '   'oExtent = oFeature.GetShape.GetBoundingBox
      '   'oExtentRectangles.Add(oExtent)

      '   'Moved code to add the features to the map to here so we will have all the features in one map, Jamie Iriwn 6/28/2016
      '   moFeatureDisplayLayer.InternalFeatures.Add(oFeature)
      '   moPrescribeShape = oFeature.GetShape
      '   moShapePartDatasets.Add(mCreateShapePartDataset(0))
      '   oSegments = moShapePartDatasets(0).Tables(LineSegment.csSegmentsTableName)
      '   Select Case moPrescribeShape.GetWellKnownType
      '      Case WellKnownType.Line, WellKnownType.Polygon
      '         'Call the new sub-routine, Jamie Iriwn 7/18/2016
      '         mAddRowToSegmentsTable(oSegments, oFeature, 1, 0)
      '      Case WellKnownType.Multiline
      '         For i As Integer = 0 To CType(moPrescribeShape, MultilineShape).Lines.Count - 1
      '            'Call the new sub-routine, Jamie Iriwn 7/18/2016
      '            mAddRowToSegmentsTable(oSegments, oFeature, 1, i)
      '         Next
      '      Case WellKnownType.Multipolygon
      '         For i As Integer = 0 To CType(moPrescribeShape, MultipolygonShape).Polygons.Count - 1
      '            'Call the new sub-routine, Jamie Iriwn 7/18/2016
      '            mAddRowToSegmentsTable(oSegments, oFeature, 1, i)
      '         Next
      '      Case Else
      '         Exit Select
      '   End Select
      'Next
      ''Now rest moPrescribeShape...
      'moPrescribeShape = moPrescribeFeature.GetShape
      oSegments.AcceptChanges()
      mSetDataSource()
      ''NOTE, moved the code below to mZoomToFullExtent so we can call it from the new map Tool, Jamie Iriwn 8/24/2016
      'mZoomToFullExtent()
      ''Moved the code to set the Extent to this routine so we can get the extent of all the features,
      ''Jamie irwin 6/28/2016
      'If oExtentRectangles.Count > 0 Then
      '   oExtent = AreaBaseShape.Union(oExtentRectangles).GetBoundingBox
      '   moDisplayMap.CurrentExtent = oExtent
      '   While Not moDisplayMap.CurrentExtent.Contains(oExtent)
      '      moDisplayMap.CurrentExtent.ScaleUp(10)
      '   End While
      'End If
   End Sub

   Private Sub mRenumberSegmentsAfterDeleteRow()
      'Added thos routine to allow us to ensure that the Segment Numbers stay sequental and start at 1
      'Jamie Irwin 7/20/2016
      'Altered to also adjust the Max Length of the Previous row an and the Min Start and MaxLength of the Next Row
      'Jamie Irwin 7/25/2016
      Dim iNewSegmentId As Integer = 0
      Dim iFeatureKey As Integer
      Dim iPartId As Integer
      Dim iSegmentId As Integer
      Dim iStart As Integer
      Dim oGridBand As UltraGridBand = ugrSegments.DisplayLayout.Bands(0)
      Dim oTrackBarEdit As UltraTrackBar = Nothing
      Dim oTrackBarRender As UltraTrackBar = Nothing
      Dim oContainer As UltraControlContainerEditor = Nothing
      Dim oSetCell As UltraGridCell = Nothing

      'For Each oRow As UltraGridRow In oGridBand.GetRowEnumerator(GridRowType.DataRow)
      '   iFeatureKey = CInt(oRow.Cells(LineSegment.csFeatureKeyCol).Value)
      '   iPartId = CInt(oRow.Cells(LineSegment.csShapePartIdCol).Value)
      '   iSegmentId = CInt(oRow.Cells(LineSegment.csSegmentNumberCol).Value)
      '   If iFeatureKey = miFeatureKeyForDelete Then
      '      If iPartId = miPartIdForDelete Then
      '         iNewSegmentId += 1
      '         If iSegmentId > iNewSegmentId Then
      '            oRow.Cells(LineSegment.csSegmentNumberCol).Value = iNewSegmentId
      '         End If
      '         If iNewSegmentId = miSegmentIdForDelete Then
      '            oRow.Activate()
      '         End If
      '         'Now adjust the Min and Max values...
      '         If oRow.Index < ugrSegments.Rows.Count - 1 Then
      '            Dim oNextRow As UltraGridRow = ugrSegments.Rows(oRow.Index + 1)
      '            If CInt(oNextRow.Cells(LineSegment.csFeatureKeyCol).Value) = iFeatureKey Then
      '               If CInt(oNextRow.Cells(LineSegment.csShapePartIdCol).Value) = iPartId Then
      '                  'This row has a Segment on this Part
      '                  iStart = CInt(oRow.Cells(LineSegment.csStartDistCol).Value)

      '                  oSetCell = oRow.Cells(LineSegment.csSetStartDistCol)
      '                  oContainer = CType(oSetCell.EditorComponent, UltraControlContainerEditor)
      '                  oTrackBarEdit = CType(oContainer.EditingControl, UltraTrackBar)
      '                  oTrackBarRender = CType(oContainer.RenderingControl, UltraTrackBar)
      '                  oTrackBarEdit.MaxValue = iStart
      '                  oTrackBarRender.MaxValue = iStart

      '                  oSetCell = oRow.Cells(LineSegment.csSetLengthCol)
      '                  oContainer = CType(oSetCell.EditorComponent, UltraControlContainerEditor)
      '                  oTrackBarEdit = CType(oContainer.EditingControl, UltraTrackBar)
      '                  oTrackBarRender = CType(oContainer.RenderingControl, UltraTrackBar)
      '                  oTrackBarEdit.MaxValue = CInt(oNextRow.Cells(LineSegment.csStartDistCol).Value) - iStart
      '                  oTrackBarRender.MaxValue = oTrackBarEdit.MaxValue

      '                  'Now set the Min for the Start and Max for the Next row
      '                  oSetCell = oNextRow.Cells(LineSegment.csSetStartDistCol)
      '                  oContainer = CType(oSetCell.EditorComponent, UltraControlContainerEditor)
      '                  oTrackBarEdit = CType(oContainer.EditingControl, UltraTrackBar)
      '                  oTrackBarRender = CType(oContainer.RenderingControl, UltraTrackBar)
      '                  oTrackBarEdit.MinValue = iStart + CInt(oRow.Cells(LineSegment.csSegmentLengthCol).Value)
      '                  oTrackBarRender.MinValue = oTrackBarEdit.MinValue

      '               Else
      '                  'This is the Last Segment for the Part so set it's Min Start and Max Length using the total lenght of
      '                  'the part and it's Start. Note we should only be here if there is a Previous Row ...

      '                  oSetCell = oRow.Cells(LineSegment.csSetLengthCol)
      '                  oContainer = CType(oSetCell.EditorComponent, UltraControlContainerEditor)
      '                  oTrackBarEdit = CType(oContainer.EditingControl, UltraTrackBar)
      '                  oTrackBarRender = CType(oContainer.RenderingControl, UltraTrackBar)
      '                  oTrackBarEdit.MaxValue = CInt(Fix(mCurrentLinePartLength(oRow))) - iStart
      '                  oTrackBarRender.MaxValue = oTrackBarEdit.MaxValue
      '               End If
      '            End If
      '         End If
      '      End If
      '   End If
      'Next
      'Added some exception code to insure we have an ActiveRow
      If IsNothing(Me.ugrSegments.ActiveRow) Then
         Me.ugrSegments.ActiveRow = Me.ugrSegments.Rows(0)
      End If
   End Sub

   Private Function mRowIsTheLastSegment(oRow As UltraGridRow) As Boolean
      'This function was added to allow us to insure that the user doesn't delete the last Segment for some
      'Feature and Part, Jamie Irwin 7/20/2016
      Dim bReturn As Boolean = True
      'Dim iFeatureKey As Integer = CInt(oRow.Cells(LineSegment.csFeatureKeyCol).Value)
      'Dim iPartId As Integer = CInt(oRow.Cells(LineSegment.csShapePartIdCol).Value)
      'Dim iSegmentId As Integer = CInt(oRow.Cells(LineSegment.csSegmentNumberCol).Value)
      'Dim oGridBand As UltraGridBand = ugrSegments.DisplayLayout.Bands(0)

      'For Each oOtherRow As UltraGridRow In oGridBand.GetRowEnumerator(GridRowType.DataRow)
      '   If CInt(oOtherRow.Cells(LineSegment.csFeatureKeyCol).Value) = iFeatureKey Then
      '      If CInt(oOtherRow.Cells(LineSegment.csShapePartIdCol).Value) = iPartId Then
      '         If CInt(oOtherRow.Cells(LineSegment.csSegmentNumberCol).Value) <> iSegmentId Then
      '            bReturn = False
      '            Exit For
      '         End If
      '      End If
      '   End If
      'Next
      Return bReturn
   End Function
   Private Sub mSetDataSource()
      Dim oGridRow As UltraGridRow
      Dim oSegmentsTable As DataTable
      Dim iShapePart As Integer = 0 'We need to get the ShapePartNumber from the new column in the grid...
      Dim oCell As UltraGridCell = Nothing
      Dim iMaxValueStart As Integer = -1
      Dim iMinValueStart As Integer = -1
      Dim iMaxValueLength As Integer = -1
      Dim iMinValueLength As Integer = -1
      Dim iCurrentLength As Integer = -1
      Dim iCurrentStart As Integer = -1

      ugrSegments.DataSource = moShapePartDatasets(iShapePart) 'cboShapeParts.SelectedIndex)
      oSegmentsTable = moShapePartDatasets(iShapePart).Tables(LineSegment.csSegmentsTableName)
      Dim oGridBand As UltraGridBand = ugrSegments.DisplayLayout.Bands(0)
      For Each oGridRow In oGridBand.GetRowEnumerator(GridRowType.DataRow)
         'We need to add some exception code to prevent errors if the original feature was edited
         'and now the Length and or distince values are nolonger valid.
         'NOTE we also change the order to do the Start distance first and variables to keep up with the max/Min values for Start and Length seperatly...
         ' Jamie Iriwn 9/13/2016
         'QB #2964, Jamie Irwin 10/12/2016, Altered code below to always call the mAdjust routines
         'NOTE that we have to set both values on all the rows before we set the MinMax values
         oCell = oGridRow.Cells(LineSegment.csSetLengthCol)
         iCurrentLength = CInt(oGridRow.Cells(LineSegment.csSegmentLengthCol).Value)
         iMaxValueLength = mGetMaxValue(oCell.Column.Key, iCurrentStart, oCell.Row)
         iMinValueLength = mGetMinValue(oCell.Column.Key, oCell.Row)
         If iCurrentLength < iMinValueLength Or iCurrentLength > iMaxValueLength Then
            If iCurrentLength < iMinValueLength Then
               iCurrentLength = iMinValueLength
            End If
            If iCurrentLength > iMaxValueLength Then
               iCurrentLength = iMaxValueLength
            End If
            oGridRow.Cells(LineSegment.csSegmentLengthCol).Value = iCurrentLength
         End If
         oGridRow.Cells(LineSegment.csSetLengthCol).Value = iCurrentLength ' oGridRow.Cells(LineSegment.csSegmentLengthCol).Value

         oCell = oGridRow.Cells(LineSegment.csSetStartDistCol)
         iCurrentStart = CInt(oGridRow.Cells(LineSegment.csStartDistCol).Value)
         iMaxValueStart = mGetMaxValue(oCell.Column.Key, iCurrentStart, oCell.Row)
         iMinValueStart = mGetMinValue(oCell.Column.Key, oCell.Row)
         If iCurrentStart < iMinValueStart Or iCurrentStart > iMaxValueStart Then
            If iCurrentStart < iMinValueStart Then
               iCurrentStart = iMinValueStart
            End If
            If iCurrentStart > iMaxValueStart Then
               If iCurrentLength > iMaxValueStart Then
                  iCurrentStart = 0
               Else
                  iCurrentStart = iMaxValueStart - iCurrentLength
               End If
            End If
            oGridRow.Cells(LineSegment.csStartDistCol).Value = iCurrentStart
         End If
         oGridRow.Cells(LineSegment.csSetStartDistCol).Value = iCurrentStart  ' oGridRow.Cells(LineSegment.csStartDistCol).Value

      Next oGridRow
      'QB #2964, Jamie Irwin 10/12/2016, Altered code below to always call the mAdjust routines
      For Each oGridRow In oGridBand.GetRowEnumerator(GridRowType.DataRow)
         mAdjustMinMaxForSegmentLengthChange(oGridRow.Cells(LineSegment.csSegmentLengthCol))
         mAdjustMinMaxForStartOfSegmentChange(oGridRow.Cells(LineSegment.csStartDistCol))
      Next oGridRow

      ugrSegments.Rows.ExpandAll(True)
      'We also need to sort the grid so the segments are with the features they are associated with...
      Dim oBand As UltraGridBand = Me.ugrSegments.DisplayLayout.Bands(0)
      Me.ugrSegments.DisplayLayout.Override.HeaderClickAction = HeaderClickAction.Select

      oBand.SortedColumns.Clear()
      oBand.SortedColumns.Add(LineSegment.csFeatureKeyCol, False, False)
      oBand.SortedColumns.Add(LineSegment.csFeatureNameCol, False, False)
      oBand.SortedColumns.Add(LineSegment.csShapePartCol, False, False)
      oBand.SortedColumns.Add(LineSegment.csSegmentNumberCol, False, False)
      'Set the first row as the ActiveRow, Jamie iriwn 7/20/2016
      'Added code to set the ActiveRow differently if we are editing existing Segmentation
      'Jamie Irwin 8/22/2016
      If IsNothing(moLineSegmentCollection) Then
         Me.ugrSegments.Rows(0).Activate()
      Else
         For Each oRow As UltraGridRow In Me.ugrSegments.Rows
            If CInt(oRow.Cells(LineSegment.csSegmentLengthCol).Value) > 0 Then
               oRow.Activate()
               Exit For
            End If
         Next
      End If
      'QB #2942, Jamie Iriwn 10/5/2016, Added call to the new routine to set the enabled property of the Add Segment button.
      mEnableAddSegmentButton()
   End Sub

   'Private Sub moDisplayMap_MapClick(sender As Object, e As ThinkGeo.MapSuite.DesktopEdition.MapClickWinformsMapEventArgs) Handles moDisplayMap.MapClick
   '   Dim oCell As UltraGridCell = ugrSegments.ActiveCell
   '   Dim iFeatureKey As Integer
   '   Dim iShapePartId As Integer

   '   If oCell Is Nothing Then
   '      Return
   '   End If
   '   'Also added a test for whcich Tool is currently selected and if it is NOT the CrussHair we get out of dodge...
   '   'Jamie irwin 7/19/2016
   '   Dim oSetPointTool As StateButtonTool = CType(utmMapTools.Tools(My.Resources.frmDynamicSegmentation.IDSetStartPoint), StateButtonTool)
   '   If IsNothing(oSetPointTool) Then
   '      Exit Sub
   '   Else
   '      If oSetPointTool.Checked = False Then
   '         Exit Sub
   '      End If
   '   End If
   '   If Not (oCell.Column.Key = LineSegment.csSegmentLengthCol Or oCell.Column.Key = LineSegment.csStartDistCol) Then
   '      Return
   '   End If

   '   iFeatureKey = CInt(oCell.Row.Cells(LineSegment.csFeatureKeyCol).Value)
   '   iShapePartId = CInt(oCell.Row.Cells(LineSegment.csShapePartIdCol).Value)
   '   Dim oCurrentLine As LineShape = mCurrentLinePart(iFeatureKey, iShapePartId)
   '   Dim oLine As MultilineShape = e.WorldLocation.GetShortestLineTo(oCurrentLine, moDisplayMap.MapUnit)

   '   If oLine Is Nothing Then
   '      Return
   '   End If
   '   'Try to see if we are close enough...
   '   'QB #2891, Increased the tollerence from 10 to 50 to try to make it less sensative,
   '   'Jamie Iriwn 9/13/2016
   '   If oLine.GetLength(moDisplayMap.MapUnit, DistanceUnit.Feet) > 50 Then
   '      Return
   '   End If

   '   '***** Get the point that actually touches the line. oLine has only two vertices, the second
   '   '***** of which should lie on oCurrentLine.
   '   '***** SET 08/30/2016
   '   Dim oPoint As PointShape = New PointShape(oLine.Lines(0).Vertices(1))
   '   Dim eStartPoint As StartingPoint = StartingPoint.FirstPoint
   '   If chkReverse.Checked Then
   '      'eStartPoint = StartingPoint.LastPoint
   '      '***** When using the GetLineOnALine method with polygons changing the StartingPoint enum from
   '      '***** StartPoint to EndPoint doesn't have any effect. So to get the line we want we instead reverse
   '      '***** the points int the source line, oCurrentLine.
   '      '***** SET 08/30/2016
   '      oCurrentLine = New LineShape(oCurrentLine.Vertices.Reverse)
   '   End If

   '   Dim oMyLineBase As LineBaseShape


   '   oMyLineBase = oCurrentLine.GetLineOnALine(eStartPoint, oPoint)

   '   'DisplayUtilities.FlashShape(oPoint, moDisplayMap)
   '   'DisplayUtilities.FlashShape(oMyLineBase, moDisplayMap)

   '   If oCell.Column.Key = LineSegment.csStartDistCol Then
   '      Dim dDistance As Double = oMyLineBase.GetLength(moDisplayMap.MapUnit, DistanceUnit.Feet)
   '      oCell.Value = dDistance
   '      mUpdateFromCellChange(oCell)
   '   Else
   '      Dim dStartDistance = CDbl(ugrSegments.ActiveRow.Cells(LineSegment.csStartDistCol).Value)
   '      Dim dDistance As Double = oMyLineBase.GetLength(moDisplayMap.MapUnit, DistanceUnit.Feet)
   '      Dim dLength = dDistance - dStartDistance
   '      oCell.Value = dLength
   '      mUpdateFromCellChange(oCell)
   '   End If


   '   moDisplayMap.Refresh(moDynamicSegmentationOverlay)
   'End Sub

   Private Sub ugrSegments_AfterCellActivate(sender As Object, e As EventArgs) Handles ugrSegments.AfterCellActivate
      Dim oCell As Infragistics.Win.UltraWinGrid.UltraGridCell = ugrSegments.ActiveCell
      ugrSegments.ActiveRow = oCell.Row
   End Sub

   Private Sub ugrSegments_AfterRowActivate(sender As Object, e As EventArgs) Handles ugrSegments.AfterRowActivate
      Dim oRow As UltraGridRow = ugrSegments.ActiveRow
      miShapePartId = CInt(oRow.Cells(LineSegment.csShapePartIdCol).Value)
      'Added the miFeatureKey column and code to reset moPrescribeFeature and Shape
      miFeatureKey = CInt(oRow.Cells(LineSegment.csFeatureKeyCol).Value)
      'For Each oFeature As Feature In moPrescribeFeatures
      '   If CInt(oFeature.ColumnValues(msFeatureKeyColumn)) = miFeatureKey Then
      '      moPrescribeFeature = oFeature
      '      moPrescribeShape = moPrescribeFeature.GetShape
      '      Exit For
      '   End If
      'Next
      mSetSelecteShapePartStyle()
      mCreateDynamicSegments()
   End Sub
   Private Sub mSetSelecteShapePartStyle()
      'Dim oLine As LineShape

      'If miShapePartId <> -1 Then
      '   oLine = mGetCurrentLine()
      '   moStartEndPointMemLayer.InternalFeatures.Clear()
      '   moSelectedPolyLayer.InternalFeatures.Clear()
      '   moSelectedPolyLayer.InternalFeatures.Add(oLine.GetFeature)

      '   mSetStartEndPointLabels(oLine)

      '   Dim oOverlays As New Collection(Of LayerOverlay)
      '   oOverlays.Add(moFeatureOverlay)
      '   oOverlays.Add(moSelectedPolyOverlay)
      '   moDisplayMap.Refresh(oOverlays)
      'End If
   End Sub


   Private Function mGetMaxValue(sKey As String, iValue As Integer, oGridRow As UltraGridRow) As Integer
      '***** The current start distance must be less than or equal
      '***** to the the distance (LinePartLength - CurrentLineLength)
      Dim iFeatureKey As Integer = CInt(oGridRow.Cells(LineSegment.csFeatureKeyCol).Value)
      Dim iShapePartId As Integer = CInt(oGridRow.Cells(LineSegment.csShapePartIdCol).Value)
      'Dim oLine As LineShape = mCurrentLinePart(iFeatureKey, iShapePartId)
      Dim iCurrentLinePartLength As Integer = 100 'CInt(oLine.GetLength(moDisplayMap.MapUnit, meDistUnits))
      Dim iCurrentSegmentLength As Integer = iValue
      Dim iStartDistance As Integer
      Dim iMaxValue As Integer
      Dim iNextStartDistance As Integer = 0
      'Dim oNextGridRow As UltraGridRow

      'If oGridRow.HasNextSibling Then
      '   oNextGridRow = oGridRow.GetSibling(SiblingRow.Next)
      '   '***** The new value is the distance from the beginning of the line
      '   iNextStartDistance = CInt(oNextGridRow.Cells(LineSegment.csStartDistCol).Value)
      'End If

      Select Case sKey
         Case LineSegment.csSegmentLengthCol, LineSegment.csSetLengthCol
            '***** The new value is the length of the line segment
            iCurrentSegmentLength = iValue
            iStartDistance = CInt(oGridRow.Cells(LineSegment.csStartDistCol).Value)
            If iNextStartDistance <> 0 Then
               'Added some exceptoin code to help catch when the Feature has been edited, Jamie Iin 9/13/2016
               If iStartDistance > iNextStartDistance Then
                  If iCurrentLinePartLength > iNextStartDistance Then
                     iMaxValue = 1  'I think this will work but it will take some testing to make sure...
                  Else
                     iMaxValue = iNextStartDistance - iCurrentLinePartLength
                  End If
               Else
                  iMaxValue = iNextStartDistance - iStartDistance
               End If
            Else
               'Added some exceptoin code to help catch when the Feature has been edited, Jamie Iin 9/13/2016
               If iStartDistance > iCurrentLinePartLength Then
                  iMaxValue = iCurrentLinePartLength
               Else
                  iMaxValue = iCurrentLinePartLength - iStartDistance
               End If
            End If
         Case LineSegment.csStartDistCol, LineSegment.csSetStartDistCol
            '***** The new value is the distance from the beginning of the line
            iStartDistance = iValue
            iCurrentSegmentLength = CInt(oGridRow.Cells(LineSegment.csSegmentLengthCol).Value)
            'Added some exceptoin code to help catch when the Feature has been edited, Jamie Iin 9/13/2016
            If iNextStartDistance <> 0 Then
               If iCurrentSegmentLength > iNextStartDistance Then
                  iMaxValue = 0
               Else
                  iMaxValue = iNextStartDistance - iCurrentSegmentLength
               End If
            Else
               If iCurrentSegmentLength > iCurrentLinePartLength Then
                  iMaxValue = iCurrentLinePartLength
               Else
                  iMaxValue = iCurrentLinePartLength - iCurrentSegmentLength
               End If
            End If
      End Select


      Return iMaxValue
   End Function
   Private Function mGetMinValue(sKey As String, oGridRow As UltraGridRow) As Integer
      Dim iFeatureKey As Integer = CInt(oGridRow.Cells(LineSegment.csFeatureKeyCol).Value)
      Dim iShapePartId As Integer = CInt(oGridRow.Cells(LineSegment.csShapePartIdCol).Value)
      'Dim oLine As Object ' LineShape = mCurrentLinePart(iFeatureKey, iShapePartId)
      Dim iCurrentLinePartLength As Integer = 100 'CInt(oLine.GetLength(moDisplayMap.MapUnit, meDistUnits))
      'Dim iPreviousSegmentLength As Integer
      'Dim iPreviousStartDistance As Integer
      'Dim oPreviousGridRow As UltraGridRow
      Dim iMinValue As Integer = 0


      Select Case sKey
         Case LineSegment.csSegmentLengthCol, LineSegment.csSetLengthCol
         Case LineSegment.csStartDistCol, LineSegment.csSetStartDistCol
            'If oGridRow.HasPrevSibling Then
            '   oPreviousGridRow = oGridRow.GetSibling(SiblingRow.Previous)
            '   '***** The new value is the distance from the beginning of the line
            '   iPreviousStartDistance = CInt(oPreviousGridRow.Cells(LineSegment.csStartDistCol).Value)
            '   iPreviousSegmentLength = CInt(oPreviousGridRow.Cells(LineSegment.csSegmentLengthCol).Value)
            '   iMinValue = (iPreviousSegmentLength + iPreviousStartDistance)
            'Else
            '   iMinValue = 0
            'End If
      End Select

      Return iMinValue
   End Function

   Private Sub ugrSegments_AfterRowsDeleted(sender As Object, e As EventArgs) Handles ugrSegments.AfterRowsDeleted
      mRenumberSegmentsAfterDeleteRow()
      mCreateDynamicSegments()
      'QB #2942, Jamie Iriwn 10/5/2016, Added call to the new routine to set the enabled property of the Add Segment button.
      mEnableAddSegmentButton()
   End Sub

   Private Sub ugrSegments_BeforeRowsDeleted(sender As Object, e As BeforeRowsDeletedEventArgs) Handles ugrSegments.BeforeRowsDeleted
      'Added code to this event to prevent the user from deleting the last row for any part and to replace the stock
      'message with our own custom message, Jamie irwin 7/20/2016
      'NOTE, the grid is currenlty set to only allow selecting of single rows!
      Dim oRow As UltraGridRow = e.Rows(0)
      Dim sMsg As String = String.Empty
      Dim iFeatureKey As Integer = CInt(oRow.Cells(LineSegment.csFeatureKeyCol).Value)
      Dim iPartId As Integer = CInt(oRow.Cells(LineSegment.csShapePartIdCol).Value)
      Dim sName As String = oRow.Cells(LineSegment.csFeatureNameCol).Text
      Dim sPart As String = oRow.Cells(LineSegment.csShapePartCol).Text
      Dim sSegment As String = oRow.Cells(LineSegment.csSegmentNumberCol).Text

      e.DisplayPromptMsg = False
      miFeatureKeyForDelete = 0
      miPartIdForDelete = -1
      miSegmentIdForDelete = 0
      If mRowIsTheLastSegment(oRow) Then
         'sMsg = String.Format(My.Resources.frmDynamicSegmentation.MsgDeletionOfLastSegmentNotAllowed, sName, sPart, sSegment)
         'InfragisticsUtils.ShowMessage(sMsg,
         '                              My.Resources.frmDynamicSegmentation.MsgDeletionOfLastSegmentCaption,
         '                              Windows.Forms.MessageBoxButtons.OK,
         '                              Windows.Forms.MessageBoxIcon.Exclamation)
         e.Cancel = True
      Else
         'It is not the last segment ask them if they are sure...
         'sMsg = String.Format(My.Resources.frmDynamicSegmentation.MsgConfirmDeleteSegment, sName, sPart, sSegment)
         Dim oResult As Windows.Forms.DialogResult = Windows.Forms.DialogResult.No
         'oResult = InfragisticsUtils.ShowMessage(sMsg,
         '                              My.Resources.frmDynamicSegmentation.MsgConfirmDeleteCaption,
         '                              Windows.Forms.MessageBoxButtons.YesNo,
         '                              Windows.Forms.MessageBoxIcon.Exclamation,
         '                              Windows.Forms.MessageBoxDefaultButton.Button2)
         If oResult = Windows.Forms.DialogResult.No Then
            e.Cancel = True
         Else
            'Set the FeatureKey and PartId member variables so we know how to set the ActiveRow and how to Renumber the Segments
            miFeatureKeyForDelete = iFeatureKey
            miPartIdForDelete = iPartId
            miSegmentIdForDelete = CInt(sSegment)
         End If
      End If
   End Sub

   Private Sub ugrSegments_CellChange(sender As Object, e As Infragistics.Win.UltraWinGrid.CellEventArgs) Handles ugrSegments.CellChange
      'Debug.WriteLine("Cell Change")
      'Added code to attempt to prevent recursive calls to mUpdateFromCellChange, 
      'Jamie Iriwn 7/19/2016
      If mbUpdateFromCellChangeIsRunning Then
         Exit Sub
      End If
      mUpdateFromCellChange(e.Cell)

      If e.Cell.Column.Key = LineSegment.csPrescribeToSegment Then
         If CBool(Boolean.Parse(e.Cell.Text)) = True Then
            'It is changing from uncheced to checked enable the button
            Me.btnPrescribe.Enabled = True
         Else
            'It is changing from Checked to Un-checked, see if any others are checked.
            Me.btnPrescribe.Enabled = mAreAnyRowsCheckedToPrescribe(e.Cell.Row.Index)
         End If
      End If
   End Sub

   Private Sub mUpdateFromCellChange(oCell As Infragistics.Win.UltraWinGrid.UltraGridCell)
      If Not IsNumeric(oCell.Text) Then
         Return
      End If
      mbUpdateFromCellChangeIsRunning = True

      Dim iMaxValue As Integer = mGetMaxValue(oCell.Column.Key, CInt(oCell.Text), oCell.Row)
      Dim iMinValue As Integer = mGetMinValue(oCell.Column.Key, oCell.Row)
      Dim oTrackBarEdit As UltraTrackBar
      'Dim oTrackBarRender As UltraTrackBar
      Dim oContainer As UltraControlContainerEditor
      Dim oSetCell As UltraGridCell
      Dim iMaxStart As Integer
      Dim sMsg As String = String.Empty

      If CInt(oCell.Text) > iMaxValue Then
         If iMaxValue > 0 Then
            oCell.Value = iMaxValue - 1
         Else
            oCell.Value = iMaxValue
         End If
      End If

      If CInt(oCell.Text) < iMinValue Then
         oCell.Value = iMinValue + 1
      End If

      Select Case oCell.Column.Key
         Case LineSegment.csSetStartDistCol
            Try
               '***** User setting the start distance, so update the 
               '***** value of the display cell
               oCell.Row.Cells(LineSegment.csStartDistCol).Value = CInt(oCell.Text)
               'And we need to rest the MaxValue on the SetSegLength
               oContainer = CType(oCell.EditorComponent, UltraControlContainerEditor)
               oTrackBarEdit = CType(oContainer.EditingControl, UltraTrackBar)
               iMaxStart = oTrackBarEdit.MaxValue
               'When the Start changes, we need to change the Max on the Length of the Previous segment, 
               'Jamie Irwin 7/25/2016
               'Use the new sub-routine, Jamie Iriwn 7/26/2016
               mAdjustMinMaxForStartOfSegmentChange(oCell)
            Catch ex As Exception
               sMsg = ex.Message
            End Try
         Case LineSegment.csSetLengthCol
            '***** The length trackbar's value has changed, so
            '***** update the corresponding cell
            oCell.Row.Cells(LineSegment.csSegmentLengthCol).Value = CInt(oCell.Text)
            'Added code to set the Min for the Start of the Next Segment, Jamie irwin 7/25/2016
            'Use the new Sub-Routine, Jamie Iriwn 7/26/2016
            mAdjustMinMaxForSegmentLengthChange(oCell)
         Case LineSegment.csSegmentLengthCol
            'Added code to test the value entered by the user against the Min/Max of the TractBar, 
            'Jamie Irwin 2/26/2016
            oSetCell = oCell.Row.Cells(LineSegment.csSetLengthCol)
            oContainer = CType(oSetCell.EditorComponent, UltraControlContainerEditor)
            oTrackBarEdit = CType(oContainer.EditingControl, UltraTrackBar)
            If CInt(oCell.Text) < oTrackBarEdit.MinValue Or CInt(oCell.Text) > oTrackBarEdit.MaxValue Then
               oCell.Appearance.ForeColor = Drawing.Color.Red
               oCell.SelectedAppearance.ForeColor = Drawing.Color.Red
               oCell.Refresh()
               mbUpdateFromCellChangeIsRunning = False
               Exit Sub
            Else
               oCell.Appearance.ForeColor = oSetCell.Appearance.ForeColor
               oCell.SelectedAppearance.ForeColor = oSetCell.SelectedAppearance.ForeColor
               oCell.Refresh()
            End If
            '***** Length column changing, update the corresponding trackbar
            oSetCell.Value = CInt(oCell.Text)
            'Use the new Sub-Routine, to adjust the Min/Max of other segments, Jamie Iriwn 7/26/2016
            mAdjustMinMaxForSegmentLengthChange(oSetCell)
         Case LineSegment.csStartDistCol
            'Added code to test the value entered by the user against the Min/Max of the TractBar, 
            'Jamie Irwin 2/26/2016
            oSetCell = oCell.Row.Cells(LineSegment.csSetStartDistCol)
            oContainer = CType(oSetCell.EditorComponent, UltraControlContainerEditor)
            oTrackBarEdit = CType(oContainer.EditingControl, UltraTrackBar)
            If CInt(oCell.Text) < oTrackBarEdit.MinValue Or CInt(oCell.Text) > oTrackBarEdit.MaxValue Then
               oCell.Appearance.ForeColor = Drawing.Color.Red
               oCell.SelectedAppearance.ForeColor = Drawing.Color.Red
               oCell.Refresh()
               mbUpdateFromCellChangeIsRunning = False
               Exit Sub
            Else
               oCell.Appearance.ForeColor = oSetCell.Appearance.ForeColor
               oCell.SelectedAppearance.ForeColor = oSetCell.SelectedAppearance.ForeColor
               oCell.Refresh()
            End If
            '***** Start distance changed, update the trackbar
            oSetCell.Value = CInt(oCell.Text)
            'Use the new sub-routine, Jamie Iriwn 7/26/2016
            mAdjustMinMaxForStartOfSegmentChange(oSetCell)
      End Select

      Try
         mCreateDynamicSegments()
      Catch ex As Exception
         sMsg = ex.Message
      End Try
      mbUpdateFromCellChangeIsRunning = False

   End Sub
   Private Sub mAddRowToSegmentsTable(ByRef oSegments As DataTable, ByVal oFeature As Object, iSegmentNumber As Integer, ByVal iShapePartId As Integer)
      'Added this routine to give us a common routine to add a new row the the Segements table, 
      'Jamie irwin 7/18/2016
      'Altered the logis to use the moLineSegmentCollection if is not nothing, Jamie Irwin 8/19/2016
      Dim oRow As DataRow
      Dim oUseLineSegment As LineSegment = Nothing

      If IsNothing(moLineSegmentCollection) = False Then
         For Each oLine In moLineSegmentCollection
            If oLine.ShapePartId - 1 = iShapePartId Then
               If oLine.Segment = iSegmentNumber Then
                  oUseLineSegment = oLine
                  Exit For
               End If
            End If
         Next
      End If

      oRow = oSegments.NewRow
      oRow(LineSegment.csPrescribeToSegment) = False
      oRow(LineSegment.csFeatureNameCol) = oFeature.ColumnValues(msNameColumn)  ' moDslFeature.DslName
      'Added the FeatureKeyColumn, Jamie Iriwn 6/28/2016
      oRow(LineSegment.csFeatureKeyCol) = oFeature.ColumnValues(msFeatureKeyColumn)
      If IsNothing(oUseLineSegment) Then
         'meStartPoint = StartingPoint.FirstPoint
         oRow(LineSegment.csShapePartCol) = (iShapePartId + 1).ToString   ' (0 + 1).ToString
         oRow(LineSegment.csSegmentNumberCol) = iSegmentNumber.ToString ' "1"
         oRow(LineSegment.csStartDistCol) = 0
         oRow(LineSegment.csSegmentLengthCol) = 0
         oRow(LineSegment.csShapePartIdCol) = iShapePartId
         oSegments.Rows.Add(oRow)
      Else
         'Use the LineSegment we found to initalize the row...
         'Reset the membervariable that controls if we set the inital length to the max
         mbSetSegmentLength = False
         'meStartPoint = CType(oUseLineSegment.StartPointId, StartingPoint)
         oRow(LineSegment.csShapePartCol) = oUseLineSegment.ShapePartId.ToString
         oRow(LineSegment.csSegmentNumberCol) = oUseLineSegment.Segment.ToString
         oRow(LineSegment.csStartDistCol) = oUseLineSegment.StartDistance
         oRow(LineSegment.csSegmentLengthCol) = oUseLineSegment.SegmentLength
         oRow(LineSegment.csShapePartIdCol) = oUseLineSegment.ShapePartId - 1
         oSegments.Rows.Add(oRow)
         'If we had one segment for this Part we may have others
         For Each oLine In moLineSegmentCollection
            If oLine.ShapePartId - 1 = iShapePartId Then
               If oLine.Segment > oUseLineSegment.Segment Then
                  oRow = oSegments.NewRow
                  oRow(LineSegment.csPrescribeToSegment) = False
                  oRow(LineSegment.csFeatureNameCol) = oFeature.ColumnValues(msNameColumn)  ' moDslFeature.DslName
                  oRow(LineSegment.csFeatureKeyCol) = oFeature.ColumnValues(msFeatureKeyColumn)
                  oRow(LineSegment.csPrescribeToSegment) = False
                  oRow(LineSegment.csShapePartCol) = oLine.ShapePartId.ToString
                  oRow(LineSegment.csSegmentNumberCol) = oLine.Segment.ToString
                  oRow(LineSegment.csStartDistCol) = oLine.StartDistance
                  oRow(LineSegment.csSegmentLengthCol) = oLine.SegmentLength
                  oRow(LineSegment.csShapePartIdCol) = oLine.ShapePartId - 1
                  oSegments.Rows.Add(oRow)
               End If
            End If
         Next

      End If
   End Sub
   Private Sub mAdjustMinMaxForSegmentLengthChange(ByRef oCell As Infragistics.Win.UltraWinGrid.UltraGridCell)
      'Added this routine to give us a common routine to adjust the Min, Max values when the Length of a Segment changes
      'Jamie Irwin 7/26/2016
      Dim oTrackBarEdit As UltraTrackBar
      Dim oTrackBarRender As UltraTrackBar
      Dim oContainer As UltraControlContainerEditor
      Dim oSetCell As UltraGridCell
      Dim iTotalLength As Integer = CInt(Fix(mCurrentLinePartLength(oCell.Row)))
      Dim iNextStart As Integer = 0

      'QB #2966, Jamie Irwin 10/13/2016, Added code to refresh the oSetCell if it is adjusted.
      'First, Adjust the Next Segment if there is one...
      If oCell.Row.Index < Me.ugrSegments.Rows.Count - 1 Then
         'it is not the Last Row
         Dim oNextSegmentRow As UltraGridRow = Me.ugrSegments.Rows(oCell.Row.Index + 1)
         If CInt(oCell.Row.Cells(LineSegment.csFeatureKeyCol).Text) = CInt(oNextSegmentRow.Cells(LineSegment.csFeatureKeyCol).Text) Then
            If CInt(oCell.Row.Cells(LineSegment.csShapePartIdCol).Text) = CInt(oNextSegmentRow.Cells(LineSegment.csShapePartIdCol).Text) Then
               'It is on the same Part of the same feature, so we need to set the Max on the Start
               oSetCell = oNextSegmentRow.Cells(LineSegment.csSetStartDistCol)
               iNextStart = CInt(oSetCell.Text)
               oContainer = CType(oSetCell.EditorComponent, UltraControlContainerEditor)
               oTrackBarEdit = CType(oContainer.EditingControl, UltraTrackBar)
               oTrackBarRender = CType(oContainer.RenderingControl, UltraTrackBar)
               oTrackBarEdit.MinValue = CInt(oCell.Row.Cells(LineSegment.csStartDistCol).Text) + CInt(oCell.Row.Cells(LineSegment.csSegmentLengthCol).Text)
               oTrackBarRender.MinValue = oTrackBarEdit.MinValue
               oSetCell.Refresh()
            End If
         End If
      End If

      'We need to adjust the Max for the SetStartDistance cell for this row...
      oSetCell = oCell.Row.Cells(LineSegment.csSetStartDistCol)
      Dim iCurrentStart As Integer = CInt(oSetCell.Text)
      oContainer = CType(oSetCell.EditorComponent, UltraControlContainerEditor)
      oTrackBarEdit = CType(oContainer.EditingControl, UltraTrackBar)
      oTrackBarRender = CType(oContainer.RenderingControl, UltraTrackBar)
      'QB #2943, Jamie Irwin, Sethe segment's new MaxStart to the Total Length - the start of the next segment if there is one
      'NOTE, this means we have to move this code below the for loop
      'oTrackBarEdit.MaxValue = CInt(iTotalLength - CInt(oCell.Row.Cells(LineSegment.csSegmentLengthCol).Text))
      Dim iPrevStart As Integer = 0
      Dim iPrevLength As Integer = 0
      If oCell.Row.Index > 0 And CInt(oCell.Row.Cells(LineSegment.csSegmentNumberCol).Value) > 1 Then
         'We need to get the Start and length of the previous segment...
         Dim oPreviousSegmentRow As UltraGridRow = Me.ugrSegments.Rows(oCell.Row.Index - 1)
         iPrevStart = CInt(oPreviousSegmentRow.Cells(LineSegment.csStartDistCol).Text)
         iPrevLength = CInt(oPreviousSegmentRow.Cells(LineSegment.csSegmentLengthCol).Text)
         If oTrackBarEdit.MinValue < iPrevStart + iPrevLength Then
            oTrackBarEdit.MinValue = iPrevStart + iPrevLength  'just to be sure...
            oTrackBarRender.MinValue = oTrackBarEdit.MinValue
         End If
      End If
      If iNextStart > 0 Then
         oTrackBarEdit.MaxValue = iNextStart - CInt(oCell.Row.Cells(LineSegment.csSegmentLengthCol).Text)
      Else
         oTrackBarEdit.MaxValue = iTotalLength - CInt(oCell.Row.Cells(LineSegment.csSegmentLengthCol).Text)
      End If
      oTrackBarRender.MaxValue = oTrackBarEdit.MaxValue
      oSetCell.Refresh()
   End Sub
   Private Sub mAdjustMinMaxForStartOfSegmentChange(ByRef oCell As Infragistics.Win.UltraWinGrid.UltraGridCell)
      'Added this routine to give us a common routine to adjust the Min, Max values when the start of a Segment changes
      'Jamie Irwin 7/26/2016
      Dim oTrackBarEdit As UltraTrackBar
      Dim oTrackBarRender As UltraTrackBar
      Dim oContainer As UltraControlContainerEditor
      Dim oSetCell As UltraGridCell
      Dim iTotalLength As Integer = CInt(Fix(mCurrentLinePartLength(oCell.Row)))

      'QB #2966, Jamie Irwin 10/13/2016, Added code to refresh the oSetCell if it is adjusted.
      'Adjust the Previous row...
      If oCell.Row.Index > 0 Then
         Dim oPreviousSegmentRow As UltraGridRow = Me.ugrSegments.Rows(oCell.Row.Index - 1)
         If CInt(oCell.Row.Cells(LineSegment.csFeatureKeyCol).Text) = CInt(oPreviousSegmentRow.Cells(LineSegment.csFeatureKeyCol).Text) Then
            If CInt(oCell.Row.Cells(LineSegment.csShapePartIdCol).Text) = CInt(oPreviousSegmentRow.Cells(LineSegment.csShapePartIdCol).Text) Then
               'It is on the same Part of the same feature, so we need to set the Max on the Start and Length,
               'Which should be the Start of the Segment being changed, Jamie Irwin 7/25/2016
               oSetCell = oPreviousSegmentRow.Cells(LineSegment.csSetStartDistCol)
               oContainer = CType(oSetCell.EditorComponent, UltraControlContainerEditor)
               oTrackBarEdit = CType(oContainer.EditingControl, UltraTrackBar)
               oTrackBarRender = CType(oContainer.RenderingControl, UltraTrackBar)
               oTrackBarEdit.MaxValue = CInt(oCell.Text) - CInt(oPreviousSegmentRow.Cells(LineSegment.csSegmentLengthCol).Text)
               oTrackBarRender.MaxValue = oTrackBarEdit.MaxValue
               oSetCell.Refresh()

               oSetCell = oPreviousSegmentRow.Cells(LineSegment.csSetLengthCol)
               oContainer = CType(oSetCell.EditorComponent, UltraControlContainerEditor)
               oTrackBarEdit = CType(oContainer.EditingControl, UltraTrackBar)
               oTrackBarRender = CType(oContainer.RenderingControl, UltraTrackBar)
               'QB #2943, Jamie Iiwn 10/5/2016, The Max Length of the Previous segment should be the start that is changing
               oTrackBarEdit.MaxValue = CInt(oCell.Text) - CInt(oPreviousSegmentRow.Cells(LineSegment.csStartDistCol).Text)
               oTrackBarRender.MaxValue = oTrackBarEdit.MaxValue
               oSetCell.Refresh()
            End If
         End If
      End If
      'We also may need to adjust the Min of the Start for the Next Segment, Jamie Iriwn 7/25/2016
      Dim iNextStart As Integer = 0
      If oCell.Row.Index >= 0 And oCell.Row.Index < Me.ugrSegments.Rows.Count - 1 Then
         Dim oNextSegmentRow As UltraGridRow = Me.ugrSegments.Rows(oCell.Row.Index + 1)
         If CInt(oCell.Row.Cells(LineSegment.csFeatureKeyCol).Text) = CInt(oNextSegmentRow.Cells(LineSegment.csFeatureKeyCol).Text) Then
            If CInt(oCell.Row.Cells(LineSegment.csShapePartIdCol).Text) = CInt(oNextSegmentRow.Cells(LineSegment.csShapePartIdCol).Text) Then
               'It is on the same Part of the same feature, so we need to set the Max on the Start and Length,
               oSetCell = oNextSegmentRow.Cells(LineSegment.csSetStartDistCol)
               iNextStart = CInt(oSetCell.Text)
               oContainer = CType(oSetCell.EditorComponent, UltraControlContainerEditor)
               oTrackBarEdit = CType(oContainer.EditingControl, UltraTrackBar)
               oTrackBarRender = CType(oContainer.RenderingControl, UltraTrackBar)
               oTrackBarEdit.MinValue = CInt(oCell.Row.Cells(LineSegment.csStartDistCol).Text) + CInt(oCell.Row.Cells(LineSegment.csSegmentLengthCol).Text)
               oTrackBarRender.MinValue = oTrackBarEdit.MinValue
               oSetCell.Refresh()
            End If
         End If
      End If
      'We need to adjust the Min for the corrsponding Length cell as well
      oSetCell = oCell.Row.Cells(LineSegment.csSetLengthCol)
      oContainer = CType(oSetCell.EditorComponent, UltraControlContainerEditor)
      oTrackBarEdit = CType(oContainer.EditingControl, UltraTrackBar)
      oTrackBarRender = CType(oContainer.RenderingControl, UltraTrackBar)
      'QB #2943, Jamie Irwin 10/5/2016, When we change the starting distance we need to calc the new Max Length using the
      'Start of the Next Segment, so we moved this block of code after we find the Next segment...
      'Which should be TotalLength- the new start - the next start 
      oTrackBarEdit.MaxValue = iTotalLength - iNextStart - CInt(oCell.Text)
      oTrackBarRender.MaxValue = oTrackBarEdit.MinValue
      oSetCell.Refresh()
   End Sub
   Private Function mAreAnyRowsCheckedToPrescribe(ByVal iRowToSkip As Integer) As Boolean
      Dim bReturn As Boolean = False
      For Each oRow As UltraGridRow In Me.ugrSegments.Rows
         If oRow.Index <> iRowToSkip Then
            If CBool(oRow.Cells(LineSegment.csPrescribeToSegment).Value) Then
               bReturn = True
               Exit For
            End If
         End If
      Next
      Return bReturn
   End Function
   Private Sub mEnableAddSegmentButton()
      'QB #2942, Jamie Iriwn 10/5/2016, Added this routine to insure that we don't allow the user
      'to add a segment if there is no where to put it.
      Dim bEnabled As Boolean = False
      Dim oActiveRow As UltraGridRow = Me.ugrSegments.ActiveRow
      Dim iLastStart As Integer = 0
      Dim iLastLength As Integer = 0
      Dim iLengthAvailable As Integer = 0
      If IsNothing(oActiveRow) = False Then
         'If there is an active row sum up all the Start Distances and Lengths and compare to the length of the line
         For Each oRow As UltraGridRow In Me.ugrSegments.Rows
            If CInt(oRow.Cells(LineSegment.csFeatureKeyCol).Value) = CInt(oActiveRow.Cells(LineSegment.csFeatureKeyCol).Value) Then
               If CInt(oRow.Cells(LineSegment.csShapePartIdCol).Value) = CInt(oActiveRow.Cells(LineSegment.csShapePartIdCol).Value) Then
                  iLastStart = CInt(oRow.Cells(LineSegment.csStartDistCol).Text)
                  iLastLength = CInt(oRow.Cells(LineSegment.csSegmentLengthCol).Text)
               End If
            End If
         Next
         Dim dLength As Double = mCurrentLinePartLength(oActiveRow)
         iLengthAvailable = CInt(Fix(dLength))

         If (iLengthAvailable - (iLastStart + iLastLength)) > 1 Then
            bEnabled = True
         End If

      End If

      Me.btnAddRow.Enabled = bEnabled
   End Sub
   Private Function mConstructSegmentShape(ByVal oRow As UltraGridRow) As Object ' LineBaseShape
      ''Created this function to have us a way to construct the shape for a segment to pass back to the Activity.
      ''The activity will save the shape to to the database.
      ''Jamie Irwin 9/8/2016
      'Dim oResultLine As LineBaseShape = Nothing
      'Dim iFeatureKey As Integer = CInt(oRow.Cells(LineSegment.csFeatureKeyCol).Value)
      'Dim oShape As BaseShape = Nothing
      'Dim oPolygon As PolygonShape
      'Dim oMultiline As MultilineShape
      'Dim oLine As LineShape
      'Dim dStartDistance As Integer
      'Dim dSegmentLength As Integer
      'Dim eStartPoint As StartingPoint = StartingPoint.FirstPoint
      'Dim iShapePartId As Integer = CInt(oRow.Cells(LineSegment.csShapePartIdCol).Value)

      'If chkReverse.Checked Then
      '   eStartPoint = StartingPoint.LastPoint
      'End If

      'For Each oFeature As Feature In moPrescribeFeatures
      '   If CInt(oFeature.ColumnValues(msFeatureKeyColumn)) = iFeatureKey Then
      '      'moPrescribeFeature = oFeature
      '      oShape = oFeature.GetShape
      '      Exit For
      '   End If
      'Next

      'Try
      '   dStartDistance = CInt(oRow.Cells(LineSegment.csStartDistCol).Text)
      '   dSegmentLength = CInt(oRow.Cells(LineSegment.csSegmentLengthCol).Text)
      'Catch ex As Exception
      '   Return Nothing
      'End Try
      'Select Case oShape.GetWellKnownType
      '   Case WellKnownType.Line
      '      oMultiline = New MultilineShape()
      '      oMultiline.Lines.Add(CType(oShape, LineShape))
      '   Case WellKnownType.Multiline
      '      oMultiline = CType(moPrescribeShape, MultilineShape)
      '   Case WellKnownType.Multipolygon
      '      oPolygon = CType(oShape, MultipolygonShape).Polygons(iShapePartId)
      '      oLine = New LineShape(oPolygon.OuterRing.Vertices)
      '      oMultiline = New MultilineShape()
      '      oMultiline.Lines.Add(oLine)
      '   Case WellKnownType.Polygon
      '      oPolygon = CType(oShape, PolygonShape)
      '      oLine = New LineShape(oPolygon.OuterRing.Vertices)
      '      oMultiline = New MultilineShape()
      '      oMultiline.Lines.Add(oLine)
      '   Case Else
      '      Return Nothing
      'End Select
      'oLine = oMultiline.Lines(0)
      'oResultLine = oMultiline.Lines(0).GetLineOnALine(eStartPoint, dStartDistance, dSegmentLength, moDisplayMap.MapUnit, DistanceUnit.Feet)
      'oResultLine.Validate(ShapeValidationMode.Simple)

      'Return oResultLine
   End Function

   Private Sub mCreateDynamicSegments()
      'Dim oResultLine As LineBaseShape
      'Dim oPolygon As PolygonShape
      'Dim oMultiline As MultilineShape
      'Dim oLine As LineShape
      'Dim dStartDistance As Integer
      'Dim dSegmentLength As Integer
      'Dim eStartPoint As StartingPoint = StartingPoint.FirstPoint
      'Dim oStartPoint As PointShape
      'Dim oEndPoint As PointShape
      'Dim oDynSegLayer As InMemoryFeatureLayer = Nothing
      'Dim sSegmentLabel As String
      'Dim sEditing As String

      'If ugrSegments.IsDisposed Then
      '   Return
      'End If

      ''If miShapePartId = -1 Then
      ''   Return
      ''End If
      'oDynSegLayer = CType(moDynamicSegmentationOverlay.Layers(0), InMemoryFeatureLayer)

      'oDynSegLayer.InternalFeatures.Clear()

      'If chkReverse.Checked Then
      '   eStartPoint = StartingPoint.LastPoint
      'End If

      ''moPointLayer.InternalFeatures.Clear()

      'Dim oGridBand As UltraGridBand = ugrSegments.DisplayLayout.Bands(0)
      'Dim iFeatureKey As Integer = 0
      'Dim iPartId As Integer = 0

      'For Each oRow As UltraGridRow In oGridBand.GetRowEnumerator(GridRowType.DataRow)
      '   'Added code to reset moPrescribeShape when the FeatureKey changes
      '   If CInt(oRow.Cells(LineSegment.csFeatureKeyCol).Value) <> iFeatureKey Then
      '      iFeatureKey = CInt(oRow.Cells(LineSegment.csFeatureKeyCol).Value)
      '      For Each oFeature As Feature In moPrescribeFeatures
      '         'NOTE we must take into account MultiPart lines as well, Jamie Iin 9/29/2016
      '         If CInt(oFeature.ColumnValues(msFeatureKeyColumn)) = iFeatureKey Then
      '            moPrescribeFeature = oFeature
      '            'moPrescribeShape = oFeature.GetShape
      '            Exit For
      '         End If
      '      Next
      '   End If

      '   'Since we want to draw the segments for all features and all parts, 
      '   'we do NOT need to look at miShapePartId, Jamie Irwin 6/28/2016
      '   'If CInt(oRow.Cells(LineSegment.csShapePartIdCol).Value) = miShapePartId Then
      '   'But we do need it when need to get the Part.
      '   miShapePartId = CInt(oRow.Cells(LineSegment.csShapePartIdCol).Value)
      '   'Rest moPrescribeShape before we call mGetCurrentLine...
      '   moPrescribeShape = moPrescribeFeature.GetShape
      '   moPrescribeShape = mGetCurrentLine() ' oFeature.GetShape
      '   sSegmentLabel = String.Empty
      '   sEditing = String.Empty
      '   If oRow.Index = ugrSegments.ActiveRow.Index Then
      '      sEditing = csEditingYes
      '   Else
      '      sEditing = csEditingNo
      '   End If
      '   Try
      '      dStartDistance = CInt(oRow.Cells(LineSegment.csStartDistCol).Text)
      '      dSegmentLength = CInt(oRow.Cells(LineSegment.csSegmentLengthCol).Text)
      '      'Added code to set the label for this segment...
      '      'Changed Segment Lable to include Row Number instead of the Name, Jamie riwn 8/23/2016
      '      'sSegmentLabel = oRow.Cells(LineSegment.csFeatureNameCol).Text + "," +
      '      sSegmentLabel = CStr(oRow.Index + 1) + "," +
      '      oRow.Cells(LineSegment.csShapePartCol).Text + "," + oRow.Cells(LineSegment.csSegmentNumberCol).Text
      '   Catch
      '      Return
      '   End Try
      '   'Replaced the If block with a Select Case, Jamie Iriwn 7/18/2016
      '   Select Case moPrescribeShape.GetWellKnownType
      '      Case WellKnownType.Line
      '         oMultiline = New MultilineShape()
      '         oMultiline.Lines.Add(CType(moPrescribeShape, LineShape))
      '      Case WellKnownType.Multiline
      '         oMultiline = CType(moPrescribeShape, MultilineShape)
      '      Case WellKnownType.Multipolygon
      '         oPolygon = CType(moPrescribeShape, MultipolygonShape).Polygons(miShapePartId)
      '         oLine = New LineShape(oPolygon.OuterRing.Vertices)
      '         oMultiline = New MultilineShape()
      '         oMultiline.Lines.Add(oLine)
      '      Case WellKnownType.Polygon
      '         oPolygon = CType(moPrescribeShape, PolygonShape)
      '         oLine = New LineShape(oPolygon.OuterRing.Vertices)
      '         oMultiline = New MultilineShape()
      '         oMultiline.Lines.Add(oLine)
      '      Case Else
      '         Exit Sub
      '   End Select
      '   'NOTE by this time oMultiline only has one per row, so we chould be able to use 0, Jamie Irwin 7/18/2016
      '   oLine = oMultiline.Lines(0)
      '   'Added code to set the Lable of the Segment 

      '   oResultLine = oMultiline.Lines(0).GetLineOnALine(eStartPoint, dStartDistance, dSegmentLength, moDisplayMap.MapUnit, DistanceUnit.Feet)
      '   'DisplayUtilities.FlashShape(oResultLine, moDisplayMap)

      '   'We also changed it so that if oResultLine is nothing we do NOT need to return...
      '   If IsNothing(oResultLine) = False Then
      '      If oResultLine.GetWellKnownType = WellKnownType.Line Then
      '         Dim oSingleLine As LineShape = CType(oResultLine, LineShape)
      '         If oSingleLine.Vertices.Count = 0 Then
      '            Continue For
      '         End If
      '         oStartPoint = New PointShape(oSingleLine.Vertices(0))
      '         oEndPoint = New PointShape(oSingleLine.Vertices(oSingleLine.Vertices.Count - 1))
      '      Else
      '         Dim oManyLine As MultilineShape = CType(oResultLine, MultilineShape)
      '         If oManyLine.Lines.Count = 0 Then
      '            Continue For
      '         End If
      '         oStartPoint = New PointShape(oManyLine.Lines(0).Vertices(0))
      '         Dim iLineCount As Integer = oManyLine.Lines.Count
      '         Dim iVertCount As Integer = oManyLine.Lines(iLineCount - 1).Vertices.Count
      '         oEndPoint = New PointShape(oManyLine.Lines(iLineCount - 1).Vertices(iVertCount - 1))
      '      End If

      '      'We must add the Column to all the features in the InMemoryFeatureLayer, including the points.
      '      Dim oColumns As New Dictionary(Of String, String)
      '      oColumns.Add(csEditing, sEditing)
      '      oDynSegLayer.InternalFeatures.Add(New Feature(oStartPoint, oColumns))
      '      oDynSegLayer.InternalFeatures.Add(New Feature(oEndPoint, oColumns))
      '      Try
      '         If oResultLine.Validate(ShapeValidationMode.Simple).IsValid Then
      '            oColumns.Add(csSegmentLable, sSegmentLabel)
      '            oDynSegLayer.InternalFeatures.Add(New Feature(oResultLine, oColumns))
      '         End If
      '      Catch
      '         Debug.WriteLine("Problem")
      '      End Try
      '   End If
      '   'End If
      'Next oRow

      ''moDisplayMap.Refresh(moDynamicSegmentationOverlay)
      ''QB #2942, Jamie Iriwn 10/5/2016, Added call to the new routine to set the enabled property of the Add Segment button.
      'mEnableAddSegmentButton()

   End Sub


   Private Sub ugrSegments_InitializeLayout(sender As Object, e As Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs) Handles ugrSegments.InitializeLayout

      e.Layout.ScrollStyle = ScrollStyle.Immediate

      e.Layout.Bands(0).Columns(LineSegment.csShapePartIdCol).Hidden = True
      'Hide the new Column that holds the FeatureKey, Jamie Iriwn 6/28/2016
      e.Layout.Bands(0).Columns(LineSegment.csFeatureKeyCol).Hidden = True
      e.Layout.Bands(0).Override.SelectTypeRow = SelectType.Single
      e.Layout.Override.RowSelectorNumberStyle = RowSelectorNumberStyle.VisibleIndex
      e.Layout.Override.RowEditTemplateUIType = RowEditTemplateUIType.None
      'Test putting it all in one band, Jamie Irwin 6/20/2016
      'e.Layout.Bands(1).Override.SelectTypeRow = SelectType.Single
      e.Layout.Bands(0).Override.AllowAddNew = AllowAddNew.No

      With e.Layout.Bands(0)
         .Columns(LineSegment.csPrescribeToSegment).CellActivation = Activation.AllowEdit
         .Columns(LineSegment.csPrescribeToSegment).Style = ColumnStyle.CheckBox
         .Columns(LineSegment.csPrescribeToSegment).AutoSizeMode = ColumnAutoSizeMode.AllRowsInBand
         .Columns(LineSegment.csFeatureNameCol).CellActivation = Activation.ActivateOnly
         .Columns(LineSegment.csFeatureNameCol).AutoSizeMode = ColumnAutoSizeMode.AllRowsInBand
         .Columns(LineSegment.csShapePartCol).CellActivation = Activation.ActivateOnly
         .Columns(LineSegment.csShapePartCol).AutoSizeMode = ColumnAutoSizeMode.AllRowsInBand
         .Columns(LineSegment.csSegmentNumberCol).CellActivation = Activation.ActivateOnly
         .Columns(LineSegment.csSegmentNumberCol).AutoSizeMode = ColumnAutoSizeMode.AllRowsInBand

         If .Columns.IndexOf(LineSegment.csSetStartDistCol) = -1 Then
            .Columns.Insert(6, LineSegment.csSetStartDistCol)
            .Columns(LineSegment.csSetStartDistCol).DataType = GetType(Integer)
            .Columns(LineSegment.csSetStartDistCol).Editor = New TrackBarEditor
            CType(.Columns(LineSegment.csSetStartDistCol).Editor, TrackBarEditor).TrackClickAction = TrackClickAction.SetValue
            .Columns(LineSegment.csSetStartDistCol).MinValue = 0
            .Columns(LineSegment.csStartDistCol).MinValue = 0
         End If
         .Columns(LineSegment.csStartDistCol).MaxWidth = 100
         .Columns(LineSegment.csStartDistCol).CellActivation = Activation.AllowEdit
         .Columns(LineSegment.csSetStartDistCol).MaxWidth = 500
         If .Columns.IndexOf(LineSegment.csSetLengthCol) = -1 Then
            .Columns.Insert(8, LineSegment.csSetLengthCol)
            .Columns(LineSegment.csSetLengthCol).DataType = GetType(Integer)
            .Columns(LineSegment.csSetLengthCol).Editor = New TrackBarEditor
            CType(.Columns(LineSegment.csSetLengthCol).Editor, TrackBarEditor).TrackClickAction = TrackClickAction.SetValue
            .Columns(LineSegment.csSetLengthCol).MinValue = 0
            .Columns(LineSegment.csSegmentLengthCol).MinValue = 0
         End If
         '.Columns(LineSegment.csSetLengthCol).MaxValue = CInt(mCurrentLinePartLength())
         '.Columns(LineSegment.csSegmentLengthCol).MaxValue = CInt(mCurrentLinePartLength())
         .Columns(LineSegment.csShapePartIdCol).Hidden = True
         .Columns(LineSegment.csSegmentLengthCol).MaxWidth = 100
         '.Columns(LineSegment.csSegmentLengthCol).Style = ColumnStyle.IntegerNonNegative
         .Columns(LineSegment.csSegmentLengthCol).MinValue = 1
         .Columns(LineSegment.csSegmentLengthCol).CellActivation = Activation.AllowEdit
         .Columns(LineSegment.csSetLengthCol).MaxWidth = 500

         .PerformAutoResizeColumns(False, PerformAutoSizeType.AllRowsInBand)
      End With
      'We need to loop through each row and set the MaxValue for each row using the feature and Part
      'associated whith that row, Jamie Iriwn 6/30/2016
      For Each oRow As UltraGridRow In Me.ugrSegments.DisplayLayout.Bands(0).GetRowEnumerator(GridRowType.DataRow)
         Dim oCell As UltraGridCell
         Dim iMax As Integer = CInt(Fix(mCurrentLinePartLength(oRow)))
         oCell = oRow.Cells(LineSegment.csSetStartDistCol)
         mSetupTrackBarForCell(oCell, 0, iMax)
         oCell = oRow.Cells(LineSegment.csSetLengthCol)
         mSetupTrackBarForCell(oCell, 1, iMax)
         If mbSetSegmentLength Then
            'Also to all the user to simply click the Rx Checkpox and press the prescribe button,
            'but only do it the fitst time the form loads, Jamie Irwin 7/1/2016
            oCell = oRow.Cells(LineSegment.csSegmentLengthCol)
            oCell.Value = iMax
            'We need to reset the Max to zero for the Start...
            oCell = oRow.Cells(LineSegment.csSetStartDistCol)
            mSetupTrackBarForCell(oCell, 0, 0)
         End If
      Next

      If mbSetSegmentLength Then
         mbSetSegmentLength = False
      End If
   End Sub
   Private Sub mSetupTrackBarForCell(ByRef oCell As UltraGridCell, ByVal iMin As Integer, ByVal iMax As Integer)
      'Added this routine to give us a mechanism to set the MaxValue seperatly for each row in the grid.
      'Jamie Iriwn 7/1/2016
      Dim oTrackBarEdit As New UltraTrackBar
      Dim oTrackBarRender As New UltraTrackBar
      Dim oContainer As New UltraControlContainerEditor

      With oTrackBarEdit
         .MinValue = iMin
         .MaxValue = iMax
      End With
      With oTrackBarRender
         .MinValue = iMin
         .MaxValue = iMax
      End With

      With oContainer
         .EditingControl = oTrackBarEdit
         .RenderingControl = oTrackBarRender
         .ApplyOwnerAppearanceToEditingControl = False
         .ApplyOwnerAppearanceToRenderingControl = False
         .EditingControlPropertyName = "Value"
         .RenderingControlPropertyName = "Value"
         .EnterEditModeMouseBehavior = EnterEditModeMouseBehavior.EnterEditModeAndClick
      End With
      oCell.EditorComponent = oContainer

   End Sub
   Private Sub chkReverse_CheckedChanged(sender As Object, e As EventArgs) Handles chkReverse.CheckedChanged
      'mSetStartEndPointLabels()
      mCreateDynamicSegments()
   End Sub

   Private Sub btnAddRow_Click(sender As Object, e As EventArgs) Handles btnAddRow.Click
      Dim oDataset As DataSet = CType(ugrSegments.DataSource, DataSet)
      Dim oSegmentsTable As DataTable = oDataset.Tables(LineSegment.csSegmentsTableName)
      Dim oDataRow As DataRow = oSegmentsTable.NewRow
      Dim oGridRow As Infragistics.Win.UltraWinGrid.UltraGridRow

      Dim iStart As Integer
      Dim iLength As Integer
      Dim iPrevStart As Integer
      Dim iPrevLength As Integer
      Dim iMax As Integer
      'Added variables for other itmes we need to keep up with
      Dim sName As String = String.Empty
      Dim iFeatureKey As Integer
      Dim iPart As Integer
      Dim iSegment As Integer
      Dim iDistanceUsed As Integer = 0
      Const iIncrimentStart As Integer = 0
      Dim oCell As UltraGridCell
      Dim oTrackBarEdit As UltraTrackBar
      'Dim oTrackBarRender As UltraTrackBar
      Dim oContainer As UltraControlContainerEditor

      'We need to get the FeatureKey from the ActiveRow...
      oGridRow = Me.ugrSegments.ActiveRow
      iFeatureKey = CInt(oGridRow.Cells(LineSegment.csFeatureKeyCol).Value)
      iPart = CInt(oGridRow.Cells(LineSegment.csShapePartIdCol).Value)
      'Then pass that to the function...
      oGridRow = mGetLastSegmentRow(iFeatureKey, iPart, iDistanceUsed)

      If oGridRow IsNot Nothing Then
         sName = oGridRow.Cells(LineSegment.csFeatureNameCol).Text
         iSegment = CInt(oGridRow.Cells(LineSegment.csSegmentNumberCol).Value) + 1
         iMax = CInt(Fix(mCurrentLinePartLength(oGridRow)))
         'Changed the code below to use .Text instead of value incase they typed in the start or length on the
         'active row and it is the "previous" row, Jamie Irwin 10/5/2016
         iPrevStart = CInt(oGridRow.Cells(LineSegment.csStartDistCol).Text)
         iPrevLength = CInt(oGridRow.Cells(LineSegment.csSegmentLengthCol).Text)

         If (iPrevStart + iPrevLength + iIncrimentStart) < iMax Then
            iStart = iPrevStart + iPrevLength + iIncrimentStart
         Else
            iStart = iPrevStart
         End If
         'QB #2943, Jamie Irwin 10/5/2016, Altered below to set iLength to iMax - something 
         iLength = iMax - iPrevStart - iPrevLength
         'We also need to reset the Max on the Start and Length of the Previuos segment
         'Jamie Iriwn 7/25/2016
         oCell = oGridRow.Cells(LineSegment.csSetStartDistCol)
         oContainer = CType(oCell.EditorComponent, UltraControlContainerEditor)
         oTrackBarEdit = CType(oContainer.EditingControl, UltraTrackBar)
         oTrackBarEdit.MaxValue = iLength
         oCell = oGridRow.Cells(LineSegment.csSetLengthCol)
         oContainer = CType(oCell.EditorComponent, UltraControlContainerEditor)
         oTrackBarEdit = CType(oContainer.EditingControl, UltraTrackBar)
         oTrackBarEdit.MaxValue = iLength

      End If
      oDataRow(LineSegment.csPrescribeToSegment) = False
      oDataRow(LineSegment.csStartDistCol) = iStart
      oDataRow(LineSegment.csSegmentLengthCol) = iLength
      oDataRow(LineSegment.csFeatureNameCol) = sName
      oDataRow(LineSegment.csFeatureKeyCol) = iFeatureKey
      oDataRow(LineSegment.csShapePartIdCol) = iPart
      oDataRow(LineSegment.csShapePartCol) = (iPart + 1).ToString
      oDataRow(LineSegment.csSegmentNumberCol) = iSegment.ToString
      'We need to get the PartNumber from the New Column...

      oSegmentsTable.Rows.Add(oDataRow)
      oSegmentsTable.AcceptChanges()
      '***** Now get the row that was added to the grid when the new row was added
      '***** to the table
      Dim oBand As UltraGridBand = Me.ugrSegments.DisplayLayout.Bands(0)

      oGridRow = Me.ugrSegments.Rows(Me.ugrSegments.Rows.Count - 1)
      ' mGetLastSegmentRow(iFeatureKey, iPart, iDistanceUsed)
      oGridRow.Cells(LineSegment.csSetStartDistCol).Value = iStart
      oGridRow.Cells(LineSegment.csSetLengthCol).Value = iLength
      'Add the Slider Editors...
      Dim iTotalLength As Integer = CInt(Fix(mCurrentLinePartLength(oGridRow)))
      iMax = iTotalLength - iPrevStart - iLength
      oCell = oGridRow.Cells(LineSegment.csSetStartDistCol)
      mSetupTrackBarForCell(oCell, iStart, iMax)
      oCell = oGridRow.Cells(LineSegment.csSetLengthCol)
      mSetupTrackBarForCell(oCell, 1, iLength)

      'And make it the ActiveRow so the Flash will work, correctly, Jamie Iriwn 6/24/2016
      oGridRow.RefreshSortPosition()
      oGridRow.Activate()

      'Now we need to call the mAdjust routines to make sure the previous segment Min/Max values is configured properlty
      oCell = oGridRow.Cells(LineSegment.csSetStartDistCol)
      mAdjustMinMaxForStartOfSegmentChange(oCell)
      oCell = oGridRow.Cells(LineSegment.csSetLengthCol)
      mAdjustMinMaxForSegmentLengthChange(oCell)

      mCreateDynamicSegments()
   End Sub
   Private Sub mFlashShapeOfActiveRow()
      'Added this sub to allow us to flash the shape associated with the currently selected row.
      'Jamie irwin 6/23/2016
      'If IsNothing(Me.ugrSegments.ActiveRow) = False Then
      '   Dim oGridRow As UltraGridRow = Me.ugrSegments.ActiveRow
      '   Dim iFeatureKey As Integer = CInt(oGridRow.Cells(LineSegment.csFeatureKeyCol).Value)
      '   Dim iShapePartId As Integer = CInt(oGridRow.Cells(LineSegment.csShapePartIdCol).Value)
      '   Dim oLine As LineShape = mCurrentLinePart(iFeatureKey, iShapePartId)
      '   MapUtilities.DisplayUtilities.FlashShape(CType(oLine, BaseShape), moDisplayMap, 3, 75, 0)
      'End If
   End Sub

   'Private Function mGetCurrentLine() As LineShape
   '   'Added this function to give us a common function to get the current line.
   '   'Jamei Irin 7/18/2016
   '   Dim oLine As LineShape = Nothing
   '   Dim oPolygon As PolygonShape

   '   If miShapePartId <> -1 Then
   '      Select Case moPrescribeShape.GetWellKnownType
   '         Case WellKnownType.Line
   '            oLine = CType(moPrescribeShape, LineShape)
   '         Case WellKnownType.Multiline
   '            oLine = CType(moPrescribeShape, MultilineShape).Lines(miShapePartId)
   '         Case WellKnownType.Multipolygon
   '            oPolygon = CType(moPrescribeShape, MultipolygonShape).Polygons(miShapePartId)
   '            oLine = New LineShape(oPolygon.OuterRing.Vertices)
   '         Case WellKnownType.Polygon
   '            oPolygon = CType(moPrescribeShape, PolygonShape)
   '            oLine = New LineShape(oPolygon.OuterRing.Vertices)
   '      End Select

   '   End If
   '   Return oLine
   'End Function

   Private Function mGetLastSegmentRow(ByVal iFeatureKey As Integer, ByVal iPartId As Integer, ByRef iDistanceUsed As Integer) As UltraGridRow
      Dim oGridBand As UltraGridBand = ugrSegments.DisplayLayout.Bands(0)
      Dim oGridRow As UltraGridRow = Nothing
      'Added iPartId so we will properly handel Multi Part features, Jamie Irin 7/20/2016
      For Each oRow As UltraGridRow In oGridBand.GetRowEnumerator(GridRowType.DataRow)
         If CInt(oRow.Cells(LineSegment.csFeatureKeyCol).Value) = iFeatureKey And CInt(oRow.Cells(LineSegment.csShapePartIdCol).Value) = iPartId Then
            iDistanceUsed = iDistanceUsed + CInt(oRow.Cells(LineSegment.csSegmentLengthCol).Value) + CInt(oRow.Cells(LineSegment.csStartDistCol).Value)
            oGridRow = oRow
         Else
            'so we don't have to look at every row...
            If IsNothing(oGridRow) = False Then
               Exit For
            End If
         End If
      Next oRow

      Return oGridRow
   End Function
   Private Function mCurrentLinePartLength(oGridRow As UltraGridRow) As Double
      Dim iFeatureKey As Integer = CInt(oGridRow.Cells(LineSegment.csFeatureKeyCol).Value)
      Dim iShapePartId As Integer = CInt(oGridRow.Cells(LineSegment.csShapePartIdCol).Value)
      'Dim oLine As LineShape = mCurrentLinePart(iFeatureKey, iShapePartId)
      Return 100 'oLine.GetLength(moDisplayMap.MapUnit, meDistUnits)
   End Function

   'Private Function mCurrentLinePart(ByVal iFeatureKey As Integer, ByVal iShapePartId As Integer) As LineShape
   '   'Added parameters so we can get the Line for a Part of some Feature,
   '   'Jamei Irwin 7/1/2016
   '   Dim oLine As BaseShape = Nothing
   '   For Each oFeature As Feature In moPrescribeFeatures
   '      If CInt(oFeature.ColumnValues(msFeatureKeyColumn)) = iFeatureKey Then
   '         moPrescribeFeature = oFeature
   '         moPrescribeShape = oFeature.GetShape
   '         'Use the new function, Jamie Iriwn 7/18/2016
   '         miShapePartId = iShapePartId
   '         oLine = mGetCurrentLine()     'oFeature.GetShape
   '         Exit For
   '      End If
   '   Next

   '   If oLine.GetWellKnownType = WellKnownType.Line Then
   '      Return CType(oLine, LineShape)
   '   Else
   '      Return CType(oLine, MultilineShape).Lines(iShapePartId)
   '   End If
   'End Function

   'Private Sub mSetStartEndPointLabels(Optional ByVal oLine As LineShape = Nothing)

   '   'Added code to call the new function, Jamie Irwin 7/18/2016
   '   If IsNothing(oLine) Then
   '      oLine = mGetCurrentLine()
   '      If IsNothing(oLine) Then
   '         Exit Sub
   '      End If
   '   End If

   '   moStartEndPointMemLayer.Open()
   '   moStartEndPointMemLayer.InternalFeatures.Clear()
   '   moStartEndPointMemLayer.EditTools.BeginTransaction()

   '   If meSourceMode = EnumSourceShapeMode.LineMode Then
   '      '***** Set a start and end point
   '      If chkReverse.Checked Then
   '         Dim oFeature As New Feature(New PointShape(oLine.Vertices(oLine.Vertices.Count - 1)))
   '         oFeature.ColumnValues.Add("Label", "Start")
   '         moStartEndPointMemLayer.EditTools.Add(oFeature)

   '         oFeature = New Feature(New PointShape(oLine.Vertices(0)))
   '         oFeature.ColumnValues.Add("Label", "End")
   '         moStartEndPointMemLayer.EditTools.Add(oFeature)
   '      Else
   '         Dim oFeature As New Feature(New PointShape(oLine.Vertices(0)))
   '         oFeature.ColumnValues.Add("Label", "Start")
   '         moStartEndPointMemLayer.EditTools.Add(oFeature)

   '         oFeature = New Feature(New PointShape(oLine.Vertices(oLine.Vertices.Count - 1)))
   '         oFeature.ColumnValues.Add("Label", "End")
   '         moStartEndPointMemLayer.EditTools.Add(oFeature)
   '      End If
   '   Else
   '      '***** Set a start/end point only
   '      Dim oFeature As New Feature(New PointShape(oLine.Vertices(0)))
   '      oFeature.ColumnValues.Add("Label", "Start/End")
   '      moStartEndPointMemLayer.EditTools.Add(oFeature)
   '   End If

   '   moStartEndPointMemLayer.EditTools.CommitTransaction()
   '   moDisplayMap.Refresh(moFeatureOverlay)
   'End Sub


   Private Sub btnClose_Click(sender As Object, e As EventArgs) Handles btnClose.Click
      Me.DialogResult = Windows.Forms.DialogResult.Cancel
      Me.Close()
   End Sub

   Private Sub btnPrescribe_Click(sender As Object, e As EventArgs) Handles btnPrescribe.Click
      'Dim oPresenter As ActivityPresenter
      'Dim oPrescribeFeatures As New Collection(Of Feature)
      'Dim oFeature As Feature
      'Dim iCurrentFeatureKey As Integer = 0
      'Dim iPrescribeLength As Integer = 0
      'Dim oLineSegment As LineSegment
      'Dim oLineSegments As New LineSegmentCollection
      'Dim iIndexOfLastRow As Integer = 0

      ''NOTE for iStartPointId if the Reverse Direction check box is checked that it is set to 1
      ''to indicate that we should use the last vertex in the part otherwise we use the first vertex which is 0
      ''Jamie irwin 8/19/2016
      'Dim iStartPointId As Integer = CInt(StartingPoint.FirstPoint)
      'If chkReverse.Checked Then
      '   iStartPointId = CInt(StartingPoint.LastPoint)
      'End If

      ''We need to look at the Grid to see which "Segemtns" have the Rx check box checked and build a list of "Feature Segements"
      ''that will be displayed on the Management Activity form.
      ''Altered the logic below to use the new LineSegment and LineSegmentCollection classes and to only put each feature
      ''in the oPrescribeFeatures collection once. Jamie irwin 8/18/2016
      ''We also need to know the index of the last visible row...
      'For Each oRow As UltraGridRow In Me.ugrSegments.Rows
      '   If oRow.Hidden = False Then
      '      iIndexOfLastRow = oRow.Index
      '   End If
      'Next
      'For Each oRow As UltraGridRow In Me.ugrSegments.Rows
      '   If oRow.Hidden = False Then
      '      If CBool(oRow.Cells(LineSegment.csPrescribeToSegment).Value) Then
      '         'We need a ColumnValues collection with DslKey, DslName and GisLength 
      '         'and we need to construct the Shape from the StartPoint, SegmentLength or get them from the moDynamicSegmentationOverlay
      '         If iCurrentFeatureKey = 0 Then
      '            iCurrentFeatureKey = CInt(oRow.Cells(LineSegment.csFeatureKeyCol).Value)
      '         End If

      '         'Added code to construct the shape, Jamie Irwin 9/9/2016
      '         Dim oLine As LineBaseShape = mConstructSegmentShape(oRow)
      '         Dim oByteShape As Byte() = Nothing
      '         If IsNothing(oLine) = False Then
      '            oByteShape = oLine.GetWellKnownBinary
      '            oLineSegment = New LineSegment(oRow, iStartPointId, oByteShape)
      '            oLineSegments.Add(oLineSegment)
      '         End If

      '         If iCurrentFeatureKey = CInt(oRow.Cells(LineSegment.csFeatureKeyCol).Value) Then
      '            iPrescribeLength = iPrescribeLength + CInt(oRow.Cells(LineSegment.csSegmentLengthCol).Value)
      '         End If

      '         If iCurrentFeatureKey <> CInt(oRow.Cells(LineSegment.csFeatureKeyCol).Value) Or oRow.Index = iIndexOfLastRow Then
      '            'Added some code to find the feature in the collection, Jamie Irwin 8/18/2016
      '            For Each o As Feature In moPrescribeFeatures
      '               If CInt(o.ColumnValues(msFeatureKeyColumn)) = iCurrentFeatureKey Then
      '                  moPrescribeFeature = o
      '                  Exit For
      '               End If
      '            Next
      '            oFeature = New Feature
      '            oFeature = moPrescribeFeature.CloneDeep
      '            oFeature.ColumnValues.Add("PrescribeLength", "PrescribeLength")
      '            oFeature.ColumnValues("PrescribeLength") = CStr(iPrescribeLength) 'oRow.Cells(LineSegment.csSegmentLengthCol).Text
      '            'oFeature.ColumnValues("Name") = oFeature.ColumnValues("Name").ToString + " (" + oRow.Cells(LineSegment.csSegmentLengthCol).Text + " ft)"
      '            oPrescribeFeatures.Add(oFeature)
      '            'Now see if the last row happens to be a different feature with just one segment...
      '            If iCurrentFeatureKey <> CInt(oRow.Cells(LineSegment.csFeatureKeyCol).Value) And oRow.Index = iIndexOfLastRow Then
      '               iCurrentFeatureKey = CInt(oRow.Cells(LineSegment.csFeatureKeyCol).Value)
      '               For Each o As Feature In moPrescribeFeatures
      '                  If CInt(o.ColumnValues(msFeatureKeyColumn)) = iCurrentFeatureKey Then
      '                     moPrescribeFeature = o
      '                     Exit For
      '                  End If
      '               Next
      '               oFeature = New Feature
      '               oFeature = moPrescribeFeature.CloneDeep
      '               oFeature.ColumnValues.Add("PrescribeLength", "PrescribeLength")
      '               iPrescribeLength = CInt(oRow.Cells(LineSegment.csSegmentLengthCol).Value)
      '               oFeature.ColumnValues("PrescribeLength") = CStr(iPrescribeLength) 'oRow.Cells(LineSegment.csSegmentLengthCol).Text
      '               'oFeature.ColumnValues("Name") = oFeature.ColumnValues("Name").ToString + " (" + oRow.Cells(LineSegment.csSegmentLengthCol).Text + " ft)"
      '               oPrescribeFeatures.Add(oFeature)

      '            End If
      '            iPrescribeLength = CInt(oRow.Cells(LineSegment.csSegmentLengthCol).Value)
      '            iCurrentFeatureKey = CInt(oRow.Cells(LineSegment.csFeatureKeyCol).Value)
      '         End If
      '      End If
      '   End If
      'Next
      'If oPrescribeFeatures.Count = 0 Then
      '   'Added this check to account for a multipart feature but only one part is selected to prescribe to, 
      '   'Jamie Irwin 9/12/2016
      '   For Each o As Feature In moPrescribeFeatures
      '      If CInt(o.ColumnValues(msFeatureKeyColumn)) = iCurrentFeatureKey Then
      '         moPrescribeFeature = o
      '         Exit For
      '      End If
      '   Next
      '   oFeature = New Feature
      '   oFeature = moPrescribeFeature.CloneDeep
      '   oFeature.ColumnValues.Add("PrescribeLength", "PrescribeLength")
      '   oFeature.ColumnValues("PrescribeLength") = CStr(iPrescribeLength) 'oRow.Cells(LineSegment.csSegmentLengthCol).Text
      '   oPrescribeFeatures.Add(oFeature)

      'End If

      ''Altered call the New to add new parameters, Jamie irwin 7/29/2016
      'oPresenter = New ActivityPresenter(miOrgKey, moSQLLayer, oPrescribeFeatures,
      '                                   ActivityPresenter.EnumPrescribeType.Management,
      '                                   ActivityPresenter.EnumPrescribeUOMType.Line,
      '                                   0,
      '                                   oLineSegments)
      'If oPresenter.DisplayCurrentActivityAttributes() = True Then
      '   For Each oRow As UltraGridRow In Me.ugrSegments.Rows
      '      If oRow.Hidden = False Then
      '         oRow.Cells(LineSegment.csPrescribeToSegment).Value = False
      '      End If
      '   Next
      '   Me.ugrSegments.Refresh()
      'End If

   End Sub

   Private Sub btnClearSegments_Click(sender As Object, e As EventArgs) Handles btnClearSegments.Click
      'Dim sMsg As String = My.Resources.frmDynamicSegmentation.MsgConfirmClearSegments
      'If InfragisticsUtils.ShowMessage(sMsg,
      '                                 My.Resources.frmDynamicSegmentation.MsgConfirmClearSegmentsCaption,
      '                                 Windows.Forms.MessageBoxButtons.YesNo, Windows.Forms.MessageBoxIcon.Question,
      '                                 Windows.Forms.MessageBoxDefaultButton.Button2) = Windows.Forms.DialogResult.Yes Then
      '   mSetupGrid()
      '   mCreateDynamicSegments()
      '   moDisplayMap.Refresh(moDynamicSegmentationOverlay)
      'End If
   End Sub

   Private Sub utmMapTools_ToolClick(sender As Object, e As UltraWinToolbars.ToolClickEventArgs) Handles utmMapTools.ToolClick

      Select Case e.Tool.Key
         'Case My.Resources.frmDynamicSegmentation.IDSetStartPoint
         '   moDisplayMap.Cursor = Windows.Forms.Cursors.Cross
         '   moDisplayMap.TrackOverlay.TrackMode = TrackMode.None
         '   moDisplayMap.ExtentOverlay.PanMode = MapPanMode.Disabled
         'Case My.Resources.frmDynamicSegmentation.IDZoomIn
         '   'Set the map Cursor to the ZoomIn cursor
         '   moDisplayMap.Cursor = Utils.MapCursorCollection.Item(My.Resources.frmDynamicSegmentation.ZoomInCursor)
         '   moDisplayMap.TrackOverlay.TrackMode = TrackMode.Rectangle
         'Case My.Resources.frmDynamicSegmentation.IDZoomOut
         '   'Set the map Cursor to the ZoomOut cursor
         '   moDisplayMap.Cursor = Utils.MapCursorCollection.Item(My.Resources.frmDynamicSegmentation.ZoomOutCursor)
         '   moDisplayMap.TrackOverlay.TrackMode = TrackMode.Rectangle
         'Case My.Resources.frmDynamicSegmentation.IDPan
         '   'Set the map Cursor to the Pan cursor
         '   moDisplayMap.Cursor = Utils.MapCursorCollection.Item(My.Resources.frmDynamicSegmentation.PanCursor)
         '   moDisplayMap.TrackOverlay.TrackMode = TrackMode.None
         '   moDisplayMap.ExtentOverlay.PanMode = MapPanMode.StandardPanning
         'Case My.Resources.frmDynamicSegmentation.IDFlash
         '   'If there is a row selected in the Grid, flash the associated shape
         '   mFlashShapeOfActiveRow()
         'Case My.Resources.frmDynamicSegmentation.IDZoomToExtentOfPart
         '   'Added tool to zoom to the extent of the part on which a segment is being edited, Jamie irwin 8/24/2016
         '   mZoomToExtentOfPart()
         'Case My.Resources.frmDynamicSegmentation.IDZoomToFullExtent
         '   'Added tool to zoom out to the full extent of all features on the Map, Jamie irwin 8/24/2016
         '   mZoomToFullExtent()
      End Select

   End Sub
   'Private Sub moTrackInteractiveOverlay_TrackEnded1(sender As Object, e As TrackEndedTrackInteractiveOverlayEventArgs) Handles moTrackInteractiveOverlay.TrackEnded
   '   Dim oOptionSet As OptionSet = utmMapTools.OptionSets(0)
   '   Dim oTools As Infragistics.Win.UltraWinToolbars.ToolsCollection = oOptionSet.Tools
   '   Dim oStateButtonTool As StateButtonTool = Nothing

   '   For Each oTool In oTools
   '      oStateButtonTool = TryCast(oTool, StateButtonTool)
   '      If Not oStateButtonTool Is Nothing Then
   '         If oStateButtonTool.Checked Then
   '            Exit For
   '         End If
   '      End If
   '   Next oTool

   '   If IsNothing(oStateButtonTool) Then
   '      Exit Sub
   '   Else
   '      Select Case oStateButtonTool.Key
   '         Case My.Resources.frmDynamicSegmentation.IDZoomIn
   '            mZoomIn(e)
   '         Case My.Resources.frmDynamicSegmentation.IDZoomOut
   '            mZoomOut(e)
   '         Case Else
   '            Exit Sub
   '      End Select
   '   End If
   'End Sub

   'Private Sub mZoomIn(ByVal e As TrackEndedTrackInteractiveOverlayEventArgs)
   '   'This new routine is based on MapUtils.MapZoom.ZoomIn written but Steve Teller for the CustomWinFormsMap.
   '   'Jamie Iriwn 6/30/2016
   '   Dim oRectangle As RectangleShape = CType(e.TrackShape, RectangleShape)
   '   Dim dRectArea As Double
   '   Dim dMapArea As Double
   '   Dim oCenterPoint As PointShape

   '   oCenterPoint = oRectangle.GetCenterPoint

   '   moDisplayMap.TrackOverlay.TrackShapeLayer.InternalFeatures.Clear()
   '   dRectArea = oRectangle.GetArea(moDisplayMap.MapUnit, AreaUnit.SquareFeet)
   '   dMapArea = moDisplayMap.CurrentExtent.GetArea(moDisplayMap.MapUnit, AreaUnit.SquareFeet)
   '   If dRectArea / dMapArea > 0.0001 Then
   '      If ExtentHelper.GetScale(oRectangle, moDisplayMap.Width, moDisplayMap.MapUnit) >= 1 Then
   '         moDisplayMap.CurrentExtent = oRectangle
   '      End If
   '   Else
   '      moDisplayMap.CenterAt(oCenterPoint)
   '      oRectangle = moDisplayMap.CurrentExtent
   '      oRectangle.ScaleDown(30)
   '      moDisplayMap.CurrentExtent = oRectangle
   '   End If
   'End Sub

   'Private Sub mZoomOut(ByVal e As TrackEndedTrackInteractiveOverlayEventArgs)
   '   'This new routine is based on MapUtils.MapZoom.ZoomOut written but Steve Teller for the CustomWinFormsMap.
   '   'Jamie Iriwn 6/30/2016
   '   Dim oRectangle As RectangleShape = CType(e.TrackShape, RectangleShape)
   '   Dim dRectArea As Double
   '   Dim dMapArea As Double
   '   Dim oCenterPoint As PointShape

   '   oCenterPoint = oRectangle.GetCenterPoint

   '   moDisplayMap.TrackOverlay.TrackShapeLayer.InternalFeatures.Clear()
   '   dRectArea = oRectangle.GetArea(moDisplayMap.MapUnit, AreaUnit.SquareFeet)
   '   dMapArea = moDisplayMap.CurrentExtent.GetArea(moDisplayMap.MapUnit, AreaUnit.SquareFeet)
   '   If dRectArea / dMapArea > 0.0001 Then
   '      '***** This is the secret formula for zooming out with a rectangle
   '      oRectangle.ScaleUp((dMapArea / dRectArea) * 100)
   '      moDisplayMap.CurrentExtent = oRectangle
   '   Else
   '      moDisplayMap.CenterAt(oCenterPoint)
   '      oRectangle = moDisplayMap.CurrentExtent
   '      oRectangle.ScaleUp(10)
   '      moDisplayMap.CurrentExtent = oRectangle
   '   End If
   'End Sub

   Private Sub mZoomToExtentOfPart()
      'Dim oRow As UltraGridRow = Me.ugrSegments.ActiveRow
      'Dim oExtent As RectangleShape = Nothing
      'Dim oLine As LineShape

      'If IsNothing(oRow) = False Then
      '   Dim iFeatureKey As Integer = CInt(oRow.Cells(LineSegment.csFeatureKeyCol).Value)
      '   Dim iShapePartId As Integer = CInt(oRow.Cells(LineSegment.csShapePartIdCol).Value)
      '   oLine = mCurrentLinePart(iFeatureKey, iShapePartId)
      '   oExtent = oLine.GetBoundingBox
      '   moDisplayMap.CurrentExtent = oExtent
      '   While Not moDisplayMap.CurrentExtent.Contains(oExtent)
      '      moDisplayMap.CurrentExtent.ScaleUp(10)
      '   End While
      '   moDisplayMap.Refresh()
      'End If
   End Sub

   'Private Sub mZoomToFullExtent()
   '   'Added this routine to allow us to zoom out to the full extent of all features,
   '   'Jamie Irwin 824/2016
   '   Dim oExtentRectangles As New Collection(Of RectangleShape)
   '   Dim oExtent As RectangleShape = Nothing

   '   For Each oFeature As Feature In moPrescribeFeatures
   '      oExtent = oFeature.GetShape.GetBoundingBox
   '      oExtentRectangles.Add(oExtent)
   '   Next
   '   If oExtentRectangles.Count > 0 Then
   '      oExtent = AreaBaseShape.Union(oExtentRectangles).GetBoundingBox
   '      moDisplayMap.CurrentExtent = oExtent
   '      While Not moDisplayMap.CurrentExtent.Contains(oExtent)
   '         moDisplayMap.CurrentExtent.ScaleUp(10)
   '      End While
   '   End If
   '   moDisplayMap.Refresh()
   'End Sub

   Private Sub ubtnSaveSegmentation_Click(sender As Object, e As EventArgs) Handles ubtnSaveSegmentation.Click
      'Added code in this event to save any changes made to the Segmentation back to the Collection and set 
      'the DialogResult to Yes so the calling reoutine know to save hose changes back to the Activity.
      'Jamie Iriwn 8/19/2016
      Dim iIndexOfLastRow As Integer = 0
      Dim iStartPointId As Integer = 0 'CInt(StartingPoint.FirstPoint)
      Dim sFeaturePartSegmentKey As String = String.Empty
      Dim oLineSegment As LineSegment = Nothing

      If chkReverse.Checked Then
         iStartPointId = 1 ' CInt(StartingPoint.LastPoint)
      End If
      'NOTE: since the SegmentNumbers can change if the Delete a row from the Grid we will simply clear out the collection
      'and reload it, and the stored procedure will only update the table rows that have changed.
      moLineSegmentCollection.Clear()

      For Each oRow As UltraGridRow In Me.ugrSegments.Rows
         'Construct a new one and add it to the collection
         'Added code to construct the shape, Jamie Irwin 9/9/2016
         'Dim oLine As LineBaseShape = mConstructSegmentShape(oRow)
         'Dim oByteShape As Byte() = Nothing
         'If IsNothing(oLine) = False Then
         '   oByteShape = oLine.GetWellKnownBinary
         'End If
         'oLineSegment = New LineSegment(oRow, iStartPointId, oByteShape)
         'moLineSegmentCollection.Add(oLineSegment)
      Next

      Me.DialogResult = Windows.Forms.DialogResult.Yes
      Me.Close()
   End Sub

   Private Sub frmDynamicSegmentationWiz_Shown(sender As Object, e As EventArgs) Handles Me.Shown
      'Moved the setting of the extent to inside mInitializeShapePartDatasets, Jamie Irwin 6/28/2016
      'moDisplayMap.CurrentExtent = moPrescribeShape.GetBoundingBox
      mSetupGrid()
      'After the Grid is Setup, we may need to set the CheckBox for the Reverse,
      'Jamie iriwn 8/19/2016
      'If meStartPoint = StartingPoint.LastPoint Then
      '   Me.chkReverse.Checked = True
      'End If
      If IsNothing(moLineSegmentCollection) Then
         Me.ubtnSaveSegmentation.Visible = False
      Else
         Me.ubtnSaveSegmentation.Visible = True
      End If
      'We also need to draw the inital segments, Jamie Irwin 7/1/2016
      mCreateDynamicSegments()
      'moDisplayMap.Refresh()
      'CType(Me.utmMapTools.Tools(My.Resources.frmDynamicSegmentation.IDSetStartPoint), StateButtonTool).Checked = True
      Me.btnPrescribe.Enabled = False

   End Sub

End Class
Public Class LineSegment
   Public Const csShapePartIdCol As String = "ShapePartId"
   Public Const csFeatureNameCol As String = "Feature"
   Public Const csFeatureKeyCol As String = "FeatureKey"  'Added a column to keep the FeatureKey, DslKey, StandKey or TractKey, Jamie Iriwn 5/28/2016
   Public Const csShapePartCol As String = "Part"
   Public Const csSegmentNumberCol As String = "Segment"
   Public Const csSetStartDistCol As String = "Set Start Distance"
   Public Const csStartDistCol As String = "Start Distance"
   Public Const csSetLengthCol As String = "Set Segment Length"
   Public Const csSegmentLengthCol As String = "Segment Length"
   Public Const csSegmentsTableName As String = "Segments"
   Public Const csShapePartsTableName As String = "ShapeParts"
   Public Const csPrescribeToSegment As String = "Rx to Segment"

   'Properties
   Public Property DmKey As Guid
   Public Property FeaturePartSegmentKey As String
   Public Property FeatureKey As Integer
   Public Property ShapePartId As Integer
   Public Property Segment As Integer
   Public Property StartPointId As Integer
   Public Property StartDistance As Integer
   Public Property SegmentLength As Integer
   Public Property ShapeBytes As Byte() = Nothing

End Class
Public Class LineSegmentCollection
   Inherits KeyedCollection(Of String, LineSegment)

   Protected Overrides Function GetKeyForItem(item As LineSegment) As String
      Return item.FeaturePartSegmentKey
   End Function
End Class